

module.exports = function(grunt) {

};

module.exports = function (grunt) {

    require('load-grunt-tasks')(grunt);

    grunt.loadTasks('game');

    var gameSrc = 'game/';
    var editSrc =  'editor/';
    var homeSrc =  'home/';

    var mainJs = 'js/main/*.js'
    var fileJs = 'js/**/*.js';
    var filecss = 'css/**/*.css';
    var fileImage = 'image/**/*';
    var filePartial = 'partials/**/*.html';
    var pageEdit = 'editor.html';
    var pageGame = 'game.html';
    var pageHome = 'home.html';
    var bow = 'js/bower_components/**/*.js';
    var dataManagerSrc = 'storage/dataManager.js';

    var destJsGame = 'js/scriptgame.js';
    var destJsEdit = 'js/scripteditor.js';
    var destJsHome = 'js/scripthome.js';
    var destCssGame = 'css/stylegame.css';
    var destCssEdit = 'css/styleeditor.css';
    var destCssHome = 'css/stylehome.css';

    var destHTML = 'html/'

    var angular  = 'js/bower_components/angular/angular.js';
    var angularCok  = 'js/bower_components/angular-cookies/angular-cookies.js';
    var angularRou  = 'js/bower_components/angular-route/angular-route.js';
    var hashes  = 'js/bower_components/jshashes/hashes.js';
    var enginecraft  = 'js/bower_components/enginecraft/engine.js';

    var destAngular  = 'js/bower_components/angular.js';
    var destEnginecraft  = 'js/bower_components/engine.js';

    var destImage = 'image/';
    var destPartial = 'partials/';



    grunt.initConfig({

        concat:{
            options: {
                separator: ';'
            },
            game: {
                src:[gameSrc+fileJs,'!'+gameSrc+bow,'!'+gameSrc+destJsGame,dataManagerSrc], 
                dest:gameSrc+destJsGame
            },
            edit: {
                src:[editSrc+mainJs, editSrc+fileJs,'!'+editSrc+bow,'!'+editSrc+destJsEdit], 
                dest:editSrc+destJsEdit
            },
            home: {
                src:[homeSrc+mainJs, homeSrc+fileJs,'!'+homeSrc+bow,'!'+homeSrc+destJsHome,dataManagerSrc], 
                dest:homeSrc+destJsHome
            },
            gameEngineEdit: {
                src:[editSrc+enginecraft], 
                dest:editSrc+destEnginecraft
            },
            gameEngineGame: {
                src:[gameSrc+enginecraft], 
                dest:gameSrc+destEnginecraft
            },
            editAgular: {
                src:[editSrc+angular,editSrc+angularCok,editSrc+angularRou], 
                dest:editSrc+destAngular
            },
            homeAgular: {
                src:[homeSrc+angular,homeSrc+angularCok,homeSrc+angularRou], 
                dest:homeSrc+destAngular
            }

        },

        concat_css:{
            game: {
                src:[gameSrc+filecss,'!'+gameSrc+destCssGame], 
                dest:gameSrc+destCssGame
            },
            edit: {
                src:[editSrc+filecss,'!'+editSrc+destCssEdit], 
                dest:editSrc+destCssEdit
            },
            home: {
                src:[homeSrc+filecss,'!'+homeSrc+destCssHome], 
                dest:homeSrc+destCssHome
            }
        },

        
        uglify:{
            game:{
                src:gameSrc+destJsGame,
                dest: gameSrc+destJsGame
            },
            edit:{
                src:editSrc+destJsEdit,
                dest: editSrc+destJsEdit
            },
            home:{
                src:homeSrc+destJsHome,
                dest: homeSrc+destJsHome
            },
            gameEngineEdit: {
                src:editSrc+destEnginecraft, 
                dest:editSrc+destEnginecraft
            },
            gameEngineGame: {
                src:gameSrc+destEnginecraft, 
                dest:gameSrc+destEnginecraft
            },
            editAgular: {
                src:homeSrc+destAngular, 
                dest:homeSrc+destAngular
            }
        },

        cssmin:{
            game:{
                src:gameSrc+destCssGame,
                dest: gameSrc+destCssGame
            },
            edit:{
                src:editSrc+destCssEdit,
                dest: editSrc+destCssEdit
            },
            home:{
                src:homeSrc+destCssHome,
                dest: homeSrc+destCssHome
            }
        },


        watch:{
            options: { spawn: false },
            game: {
                files:[gameSrc+fileJs,'!'+gameSrc+bow,'!'+gameSrc+destJsGame,dataManagerSrc,gameSrc+filecss,'!'+gameSrc+destCssGame], 
                tasks:['concat:game','concat_css:game']
            },
            edit: {
                files:[editSrc+mainJs, editSrc+fileJs,'!'+editSrc+bow,'!'+editSrc+destJsEdit, editSrc+filecss,'!'+editSrc+destCssEdit], 
                tasks:['concat:edit','concat_css:edit']
            },
            home: {
                files:[homeSrc+mainJs, homeSrc+fileJs,'!'+homeSrc+bow,'!'+homeSrc+destJsHome,dataManagerSrc,homeSrc+filecss,'!'+homeSrc+destCssHome], 
                tasks:['concat:home','concat_css:home']
            }
        }
  });

    grunt.registerTask('packageDev', ['concat','concat_css']);
    grunt.registerTask('packageProd', ['concat','concat_css','concat_css','uglify','cssmin']);

};
