
module.exports = function(grunt) {
    grunt.registerTask('packageDataGame', function() {
        var dir = 'game/data/skin/template/';
        var dirLevel = 'game/data/level/';
        var dirSkins = 'game/data/skin/';
        var dirHome = 'home/data/';
        var i = 0;
        var worldMap = [];
        grunt.file.recurse(dir, function(path, rootdir, subdir, filename){

            var pkg = grunt.file.readJSON(path);
            var newJson = {};
            newJson.player = grunt.file.readJSON( dirSkins+'skinsPlayer/'+pkg.player+'.json');
            newJson.oils = [];
            i = pkg.oils.length;
            while(i--){
              newJson.oils[i] = grunt.file.readJSON( dirSkins+'skinsOil/'+pkg.oils[i]+'.json');
            }
            newJson.mobs = [];
            i = pkg.mobs.length;
            while(i--){
              newJson.mobs[i] = grunt.file.readJSON( dirSkins+'skinsMob/'+pkg.mobs[i]+'.json');
            }

            newJson.bundle = grunt.file.readJSON( dirSkins+'bundle/bundle.json');

            newJson.level = grunt.file.readJSON( dirSkins+'skinsLevel/'+pkg.level+'.json');

            worldMap.push({sectionId:filename.replace('.json',''),levels:[]});

            grunt.file.write(dirSkins+filename, JSON.stringify(newJson));
        });

        grunt.file.recurse(dirLevel, function(path, rootdir, subdir, filename){
            var dataLevel = grunt.file.readJSON(path);

            var i = worldMap.length
            while(i--){
                if(worldMap[i].sectionId == dataLevel.skinId){
                    worldMap[i].levels.push({
                        id:dataLevel.name,
                        scorerange:dataLevel.scorerange||100
                    });
                }
            }
        });
        grunt.file.write(dirSkins+"worldMap.json", JSON.stringify(worldMap));
        grunt.file.write(dirHome+"worldMap.json", JSON.stringify(worldMap));

    });
}