
GameManager = function(dataLevel){

   this.m_targetPosition;
   this.m_beginPosition;
   this.m_targetScore;
   this.m_targetTimer;
   this.m_targetFailure;
   this.m_timeout;
   this.m_player;

   this.m_gameFinished;

   this.m_watchedScore = {value:null};
   this.m_watchedHP = {value:null};
   this.m_watchedVictory = {value:null};
   this.m_watchedLoose = {value:null};
   this.m_watchedOil = {value:null};

   this.m_targetMob;
   this.m_counter;
   this.m_failure;

   this.m_modeTP;
   this.m_modeSW;
   this.m_modeT;
   this.m_modeS;
   this.m_modeTM;

   this.c_initModel( dataLevel);


};

GameManager.prototype.c_initModel = function(data){

 	this.m_isManager = true;
 	if(data.targetPlayer){
			this.m_targetPosition = new Engine.Vector3(data.targetPlayer[0],0,data.targetPlayer[1]);
	}
	if(data.beginPlayer&&data.beginPlayer.length)
	this.m_beginPosition = new Engine.Vector3(data.beginPlayer[0],0,data.beginPlayer[1]);

	this.m_gameFinished = false;


	this.m_targetFailure = 5;
	this.m_targetTimer = data.timeTarget;
	this.m_targetScore = data.scoreTarget;

	this.m_timeout = data.timeout;

	this.m_failure = 0;
	this.m_counter = 0;

};

GameManager.prototype.c_setPlayer = function(player){
	 this.m_player = player ;
};


GameManager.prototype.c_mobWin = function(mob){
	this.m_gameFinished = true
	this.m_player.c_lose();

};

GameManager.prototype.c_playerWin = function(){
	this.m_gameFinished = true
	this.m_player.c_win();
};


GameManager.prototype.c_playerLose = function(mob){
	this.m_gameFinished = true;
	this.m_player.c_lose();
};



GameManager.prototype.c_update = function(t){

	if(this.m_gameFinished)return;

	this.c_checkTargetPosition();
	this.c_checkBeginPosition();
	this.c_checkPlayerLife();
	this.c_checkPlayerScore();
	this.c_checkTimeout();
	this.c_checkOil();

	this.m_counter += t; 

};




GameManager.prototype.c_checkOil = function(){

	this.m_watchedOil.value = this.m_player.m_currentOil;
};


GameManager.prototype.c_checkTargetPosition = function(){
	if(this.m_player.m_hasTreasure || !this.m_targetPosition)return;

	if(this.m_player.m_position.distanceTo(this.m_targetPosition)<2){
		this.m_player.c_getTreasure();
		sm.play('assets/sound/tresor.mp3',0);

	}
	
	
};


GameManager.prototype.c_checkBeginPosition = function(){
	if(this.m_beginPosition)
	if(this.m_player.m_position.distanceTo(this.m_beginPosition)<2){
		dM = new dataManager();
    	var treasure = dM.getHasTreasure(true);	
		if(treasure){
			this.c_playerWin();
			this.m_watchedVictory.value = true;
		}
	}
	
};


GameManager.prototype.c_checkPlayerLife = function(){
	this.m_watchedHP.value = this.m_player.m_hp;
	if(this.m_player.m_hp<1){
		this.c_playerLose();
		this.m_watchedLoose.value = true;
		sm.play('assets/sound/gameover.mp3',0);
	}
	
};

GameManager.prototype.c_checkPlayerScore = function(){
	this.m_watchedScore.value = this.m_player.m_score;
	if(this.m_targetScore && this.m_player.m_score>=this.m_targetScore){
		this.c_playerWin();
		this.m_watchedVictory.value = true;
	}
	
};


GameManager.prototype.c_checkTimeout = function(){

	if(this.m_timeout && this.m_counter>=this.m_timeout){
		this.c_playerLose();
		this.m_watchedLoose.value = true;
	}
	
};

GameManager.prototype.c_MobTakeTarget = function(){
	this.m_failure++;
	if(this.m_failure>this.m_targetFailure){
		this.c_mobWin();
		this.m_watchedLoose.value = true;
	}

};


GameManager.prototype.c_checkTargetTimer = function(){

	if(this.m_targetTimer && this.m_counter>=this.m_targetTimer){
		this.c_playerWin();
		this.m_watchedVictory = {value:true};
	}
	
};





