
Level = function(dataGlobal,dataWorld){

    /******************************************************/
	/**********************MODEL***************************/
	/******************************************************/

	this.m_tileSize;
	this.m_world;
	this.m_scene;
	this.m_material;
	this.m_light;
	this.m_subLight = [];
	this.m_meshTiles = [];
	this.m_meshElements = [];
	this.m_matrixMap = [];
	this.m_matrixBlock = [];
	this.m_matrixDynamicBlock = [];
	this.m_dynamicBlocks = [];
	this.m_N;
	this.m_M;
	this.m_sizeN;
	this.m_sizeM;
	this.m_destructor;

	this.m_ctn;

	this.m_blockSize;
	this.m_blockFactor;

	this.m_hasShadow = true;
	this.m_cameraShadow;
	this.m_meshTreasure;
	this.m_Spike = [];
	this.m_spike = [];

	this.c_initModel(dataGlobal,dataWorld);
};

Level.prototype.c_initModel = function(dataGlobal,dataWorld){

	this.m_tileSize = dataGlobal.tileSize;
	this.m_world = dataWorld.model;
	this.m_N = dataGlobal.nWidth;
	this.m_M = dataGlobal.nHeight;
	this.m_sizeN = this.m_N * this.m_tileSize;
	this.m_sizeM = this.m_M * this.m_tileSize;
	this.m_name = dataWorld.name;
	var i,il;

	this.m_blockFactor = 5;
	this.m_blockSize = this.m_tileSize/this.m_blockFactor;
	this.m_halfblock =  this.m_blockSize/2;

	this.m_destructor = dataWorld.destructor;



	this.m_ctn = 0;


	//creation de la matrixMap
	for(i=0; i<this.m_N; i++){
		this.m_matrixMap[i] = [];
		for(var j=0; j<this.m_M; j++){
			this.m_matrixMap[i][j] = null;
		}
	}

	this.m_material = new Engine.MeshPhongMaterial( { map: new Engine.Texture( dataGlobal.tilesMap),transparent:true, shininess:0,normalMap: new Engine.Texture( dataGlobal.tilesNormal) } );

	this.m_material2 = new Engine.MeshPhongMaterial( { map: new Engine.Texture( "assets/textures/light.jpg"), lightMap : new Engine.Texture( "assets/textures/lightlum.jpg")} );

	this.m_material3 = new Engine.MeshPhongMaterial( { map: new Engine.Texture( "assets/textures/blood.png"),transparent:true});

	//this.m_material4 = new Engine.MeshPhongMaterial( { map: new Engine.Texture( dataGlobal.tilesMap),transparent:true,shininess:10 } );

	var geoTiles = [];
	for(i=0,il=dataGlobal.tiles.length;i<il;i++) {
		geoTiles.push(new Engine.ObjGeometry( dataGlobal.tiles[i] )) ;
	}
	var geoElements = [];
	for(i=0,il=dataGlobal.elements.length;i<il;i++) {

		if(i==22){
			geoElements.push(new Engine.ObjGeometry( dataGlobal.elements[i] ));
		}else
		geoElements.push( new Engine.ObjGeometry( dataGlobal.elements[i] ));
		/*if ( dataGlobal.elements[i].index == 0  ) {
			 this.m_Spike.push( {dataGlobal.elements[i].x, dataGlobal.elements[i].y})
		}*/
	}

	var world = this.m_world;
	var d = this.m_tileSize;


	for(i=0, il=world.length; i<il;i++){

		var block = world[i];

		if(!this.m_meshTiles[block.id]){
			this.m_meshTiles[block.id] = new Engine.Mesh( geoTiles[block.id], this.m_material, false, this.m_hasShadow );

		}

		var positionX = block.pos[0];
		var positionY = 0;
		var positionZ = block.pos[1];

		var nm = this.c_positionToIndex(positionX,positionZ);

		var tile = this.m_matrixMap[nm[0]][nm[1]] = {id:block.id,geo:geoTiles[block.id],elements:[],mobs:block.mob||[],oils:block.wea||[],destructor:false};

		this.m_meshTiles[block.id].addClone(positionX,positionY,positionZ,0,block.rot*Math.PI,0,0,0,block.symmetry?-1:1,1);	
		for(var k=0, kl=block.ele.length; k<kl;k++){	
			var element = block.ele[k];
			if(!this.m_meshElements[element.id]){

				if(element.id==9){
					this.m_meshElements[element.id] = new Engine.Mesh( geoElements[element.id], this.m_material2, this.m_hasShadow );
				}else if(element.id==11){
					this.m_meshElements[element.id] = new Engine.Mesh( geoElements[element.id], this.m_material3 );
				}else if(element.id==21){
					this.m_meshElements[element.id] = new Engine.Mesh( geoElements[element.id], this.m_material, this.m_hasShadow );
					this.m_spike.push(this.m_meshElements[element.id]);
				}else if(element.id==22){
					this.m_meshElements[element.id] = new Engine.Mesh( geoElements[element.id], this.m_material );
					this.m_spike.push(this.m_meshElements[element.id]);
					//this.m_meshElements[element.id].setAnimation([{"index": 1,"step": 0},{"index": 1,"step": 1}],600,false);

				}else{
					this.m_meshElements[element.id] = new Engine.Mesh( geoElements[element.id], this.m_material, this.m_hasShadow );
				}


			}
			var elepos = new Engine.Vector3(element.pos[0],0,element.pos[1]);
			this.m_meshElements[element.id].addClone(elepos.x,elepos.y,elepos.z,0,element.rot*Math.PI,0,0,0,element.sym?-1:1,1);	
		}
	}

	//init destructor

	for(i=0, il=this.m_destructor.length; i<il;i++){
		 this.c_positionToTile(this.m_destructor[i][0],this.m_destructor[i][1]).destructor = true;
	}


	for(i=0,il=dataWorld.lights.length;i<il;i++ ){
		var l = dataWorld.lights[i];
		var newLight = new Engine.PointLight( l.color, 1.0 , l.radius, l.pos );
		this.m_subLight.push(newLight);
	}

	dM = new dataManager();
	if(dataWorld.beginPlayer&&dataWorld.beginPlayer.length&&!dM.getHasTreasure()){
		this.m_meshTreasure = new Engine.Mesh(  new Engine.ObjGeometry( 'assets/obj/elements/chest.obj' ), this.m_material );
		this.m_meshTreasure.position = new Engine.Vector3(dataWorld.targetPlayer[0],0,dataWorld.targetPlayer[1]);
	}
	
};

Level.prototype.c_ready = function(){

	var i,il;

	for(i=0, il=this.m_meshTiles.length; i<il;i++){
		if(this.m_meshTiles[i]){
			this.m_meshTiles[i].geometry.computeBoundingBox();
			if(this.m_meshTiles[i].geometry.boundingBox.max.y>1){
				
				this.m_meshTiles[i].geometry.collision = true;
			}else{
				this.m_meshTiles[i].geometry.collision = false;
			}
		}
	}
	for(i=0, il=this.m_meshElements.length; i<il;i++){
		if(this.m_meshElements[i]){
			this.m_meshElements[i].geometry.computeBoundingBox();
			if(this.m_meshElements[i].geometry.boundingBox.max.y>0.1){
				this.m_meshElements[i].geometry.collision = true;
			}else{
				this.m_meshElements[i].geometry.collision = false;
			}
		}
	}



	//on recupere les elements pouvant provoquer des collision;
	var tile;
	for(i=0; i<this.m_N; i++){
		for(var j=0; j<this.m_M; j++){
			tile = this.m_matrixMap[i][j];
			if(tile){
				if(this.m_meshTiles[tile.id].geometry.collision){
					tile.collision = true;
				}else{
					tile.collision = false;
				}
			}
		}
	}

	var world = this.m_world;

	for(i=0, il=world.length; i<il;i++){

		var block = world[i];
		
		var positionX = block.pos[0];
		var positionY = 0;
		var positionZ = block.pos[1];
		tile = this.c_positionToTile(positionX,positionZ);

		for(var k=0, kl=block.ele.length; k<kl;k++){
			var element = block.ele[k];
			var elementPosition = new Engine.Vector3(element.pos[0],0,element.pos[1]);
			if(this.m_meshElements[element.id].geometry.collision){
				tile.elements.push({ 
					id:element.id,
					mesh:this.m_meshElements[element.id].geometry,
					position:elementPosition,
					boundingBox:this.m_meshElements[element.id].geometry.boundingBox.clone().translate(elementPosition)
					});
			}
		}

	}
	
	this.c_generateCollisionBlocks();
};

Level.prototype.c_generateCollisionBlocks = function(){

	var x,z,box, tile,closed;
	var width = this.m_N * this.m_blockFactor;
    var height =  this.m_M * this.m_blockFactor;
    var f = this.m_blockFactor;
	var i,j;

	this.m_matrixBlock = new Array(width);
	for (i = 0; i < width; ++i) {
		this.m_matrixBlock[i] = new Array(height);
		for (j = 0; j < height; ++j) {

			x = i*this.m_blockSize;
			z = j*this.m_blockSize;
			
			tile = this.m_matrixMap[Math.floor(i/f)][Math.floor(j/f)];
			box = new Engine.Box3( new Engine.Vector3(x,-1,z),new Engine.Vector3(x+this.m_blockSize,10,z+this.m_blockSize));

			if(!tile || tile.collision){
				this.m_matrixBlock[i][j] = true;
			}else if( this.c_checkCollisionElementsToBox(box,tile) ){
				this.m_matrixBlock[i][j] = true;
			}else{
				this.m_matrixBlock[i][j] = false;
			}
		}

	}



	this.m_matrixDynamicBlock = new Array(width);
	for (i = 0; i < width; ++i) {
            this.m_matrixDynamicBlock[i] = new Array(height);
    }

};

Level.prototype.c_generateCollisionDynamicBlocks = function(){

  		var width = this.m_N * this.m_blockFactor;
        var height =  this.m_M * this.m_blockFactor;
        var db = this.m_dynamicBlocks;
        var blocks = this.m_matrixDynamicBlock;
        var i, j;
        var pos;
        i = width;
        while(i--) {
        	j = height;
            while(j--) {
                blocks[i][j] = false;
            }
        }
        i = db.length;
		while(i--) {
				pos = db[i].m_position;
				blocks[Math.floor(pos.x/this.m_blockSize)][Math.floor(pos.z/this.m_blockSize)] = true;
		}
};

//block de collision pour le pathfinding

Level.prototype.c_getBlockByIndex = function( n,m ) {
	if(this.m_matrixBlock[n][m]){
		return true;
	}else if(this.m_matrixDynamicBlock[n][m]){
		return true;
	}else{
		return false;
	}
};

//index de la matrix des block pathfinding
Level.prototype.c_positionToIndexBlock = function( v1,v2 ) {
	var nt = Math.floor(v1/this.m_blockSize);
	var mt = Math.floor(v2/this.m_blockSize);
	return [n,m];
};

Level.prototype.c_positionToIndex = function(v1,v2){
	var n = Math.floor(v1/this.m_tileSize);
	var m = Math.floor(v2/this.m_tileSize);
	return [n,m];
};

Level.prototype.c_IndexToPosition = function(n,m){
	var x = n * this.m_tileSize;
	var z = m * this.m_tileSize;
	return new Engine.Vector3(x,0,z);
};

Level.prototype.c_positionToTile = function(v1,v2){
	var n = Math.floor(v1/this.m_tileSize);
	var m = Math.floor(v2/this.m_tileSize);
	if(this.m_matrixMap[ n ]){
		return this.m_matrixMap[ n ][ m ];
	}
};

Level.prototype.c_IndexToTile = function(n,m){
	if(this.m_matrixMap[ n ]){
		return this.m_matrixMap[ n ][ m ];
	}
};

Level.prototype.c_addDynamicCollisionBlock = function(block){
	this.m_dynamicBlocks.push(block);
};

Level.prototype.c_removeDynamicCollisionBlock = function(block){
	var db = this.m_dynamicBlocks;
	for (var i = db.length - 1; i >= 0; i--) {
		if(db[i]==block){
			db.splice(i,1);
			return;
		}
	}
};



Level.prototype.c_update = function(t){

     this.m_light.color.r =1;
     this.m_light.color.g =1;
     this.m_light.color.b =1;



    /* for(var i=0,il=this.m_spike.length;i<il;i++){
     	if(this.m_spike[i].update){
     		this.m_spike[i].update(t);
     	}
     }*/



	//if(this.m_ctn>10){
		//this.m_ctn = 0;
		this.c_generateCollisionDynamicBlocks();
	//}else{
	//	this.m_ctn+=t;
	//}
	
};


/*Level.prototype.c_checkCollision = function(position,radius){
	var n = Math.floor(position.x/this.m_tileSize);
	var m = Math.floor(position.z/this.m_tileSize);
	var tile = this.m_matrixMap[ n ][ m ];
    var i;
	var collision = false;

	if(tile){
		if(tile.collision){
			collision = true;
		}else{
			i = tile.elements.length;
			while(i--){
				if( tile.elements[i].boundingBox.distanceToPoint(position)<radius){
					collision = true;
					break;
				}
			}
		}
	}else{
		collision = true;
	}
	return collision;

}*/



Level.prototype.c_checkCollision = function(position,radius){
	var n = Math.floor(position.x/this.m_tileSize);
	var m = Math.floor(position.z/this.m_tileSize);
	var row = this.m_matrixMap[ n ];
	var tile;
	var i;
	if(!row) return true;

	tile = row[ m ];

	if(tile&&!tile.collision){
			i = tile.elements.length;
			while(i--){
				if( tile.elements[i].boundingBox.distanceToPoint(position)<radius){
					return true;
				}
			}
	}else{
		return true;
	}
	return false;

};

Level.prototype.c_checkCollisionElementsToBox = function(box,tile){
	var i = tile.elements.length;
	while(i--){
		if( box.isIntersectionBox( tile.elements[i].boundingBox)){
			return true;
		}
	}
	return false;
};


Level.prototype.c_updateLight = function(x,z){
	var l;
	for(k=0, kl=this.m_subLight.length; k<kl;k++){
		l = this.m_subLight[k];

		if(Math.abs(x-l.position.x)<25&&Math.abs(z-l.position.z)<25){
			l.intensity=1;
		}else{
			l.intensity=0;
		}
		this.m_scene._lightsNeedUpdate = true;

	}
}


/*
Level.prototype.c_checkIntersection = function(px1,pz1,px2,pz2,radius){

	var collision = false;d
	var n1 = Math.floor(px2/this.m_tileSize);
	var m1 = Math.floor(pz2/this.m_tileSize);
	var tile = this.m_matrixMap[ n1 ][ m1 ];

	var v,b;
	//Tile de destination bloquee ?
	if(tile.collision) { 
		return true;
	}

	//collisions ELEMENTS de la tile arrivee
	//return true or conntinue
	if(this.checkIntersectionElements(px1,pz1,px2,pz2,tile)){
		return true;
	}

	var n2 = Math.floor(px1/this.m_tileSize);
	var m2 = Math.floor(pz1/this.m_tileSize);

	if(n1 == n2 && m1 == m2 ){ //meme tile  depart==arrivee

		return false;

	}else {

		tile = this.m_matrixMap[ n2 ][ m2 ];

		if(this.checkIntersectionElements(px1,pz1,px2,pz2,tile)){
			return true;
		}
		//collisions ELEMENTS de la tile de depart	
		//return true or conntinue

		if ( n1 == n2  || m1 == m2) { //tile haut ou bas ou droite ou gauche

			return false
		
		}else{ // on vient d'un tile diagonal, il est possible de traverser un tile entre le depart et la destination


			var n3,m3, n4,m4, minx,minz, a;

			if(n1>n2){ //block de gauche
				if(m1>m2){ //block du bas //G B
					n3 = n1-1; m3=m1; 
					n4 = n1; m4=m1-1; 
				}else if (m1<m2){ //block du haut // G H
					n3 = n1-1; m3=m1; 
					n4 = n1; m4=m1+1; 
				}

			}else if(n1<px2) { //block de droite 
				if(m1>m2){ //block du bas // D B
					n3 = n1+1; m3=m1; 
					n4 = n1; m4=m1-1; 	

				}else if (m1<m2){ //block du haut  // D H
					n3 = n1+1; m3=m1; 
					Math.intersectionSegBox(px1,pz1,px2,pz2,);
					n4 = n1; m4=m1+1; 
				}

			}

			minx =  (n3)*this.m_tileSize; 
			minz =  (m3)*this.m_tileSize;
			a = Math.intersectionSegBox(px1,pz1,px2,pz2,minx,minx+this.m_tileSize,minz,minz+this.m_tileSize);
			if(a){
				tile = this.m_matrixMap[ n3 ][ m3 ];
				if(tile.collision) { 
					return true;
				}else{
					//collisions ELEMENTS de la tile traverse
					//return true or false
					return this.checkIntersectionElements(px1,pz1,px2,pz2,tile);
				}
			}

			minx =  (n4)*this.m_tileSize; 
			minz =  (m4)*this.m_tileSize;
			a = Math.intersectionSegBox(px1,pz1,px2,pz2,minx,minx+this.m_tileSize,minz,minz+this.m_tileSize);
			if(a){
				tile = this.m_matrixMap[ n4 ][ m4 ];
				if(tile.collision) { 
					return true;
				}else{
					//collisions ELEMENTS de la tile traverse
					//return true or false	
					return this.checkIntersectionElements(px1,pz1,px2,pz2,tile);
				}
			}

		}

	}

}

Level.prototype.c_checkIntersectionElements = function(px1,pz1,px2,pz2,tile){
	var element,pos,box, a;
	for(var i=0, il=tile.elements.length; i<il;i++){

		element = tile.elements[i];
		pos = element.position;
		box = element.boundingBox;

		a = Math.intersectionSegBox(px1,pz1,px2,pz2, pos.x+box.xmin,pos.x+box.xmax,pos.z+box.zmin,pos.z+box.zmax);

		if(a)
			return true;
		else
			return false;
	}

}*/





/**********************************************************************************/
/**********************CONTROLLER PRIMAIRE*****************************************/
/**********************************************************************************/

Level.prototype.add = function(scene) {
	var k=0, kl;
	this.m_scene = scene;

	this.m_light = new Engine.PointLight( 0xffffff, 0.1 , 40, [7,15,8] );

	this.m_scene.add(this.m_light);


	if(this.m_hasShadow){
		this.m_cameraShadow = new Engine.OrthographicCamera( -20, 20, 20, -20, 1, 200, "cameraDepth" );
		//this.m_cameraShadow.position = this.m_light.position;
		//this.m_cameraShadow.lookAt(new Engine.Vector3(this.m_light.position.x,0,this.m_light.position.z));

		this.m_cameraShadow.position = new Engine.Vector3(10,40,10);
		this.m_cameraShadow.lookAt(new Engine.Vector3(15,0,15));

		this.m_scene.add(this.m_cameraShadow);
	}

	for( k=0, kl=this.m_meshTiles.length; k<kl;k++){
		this.m_scene.add(this.m_meshTiles[k]);
	}
	for( k=0, kl=this.m_meshElements.length; k<kl;k++){
		this.m_scene.add(this.m_meshElements[k]);
	}

	for(k=0, kl=this.m_subLight.length; k<kl;k++){
		this.m_scene.add(this.m_subLight[k]);
	}

	if(this.m_meshTreasure)
		this.m_scene.add(this.m_meshTreasure);
};


Level.prototype.remove = function(scene) {
	var k=0, kl;
	for(k=0, kl=this.m_meshTiles.length; k<kl;k++){
		this.m_scene.remove(this.m_meshTiles[k]);
	}
	for( k=0, kl=this.m_meshElements.length; k<kl;k++){
		this.m_scene.remove(this.m_meshElements[i]);
	}
	for( k=0, kl=this.m_subLight.length; k<kl;k++){
		this.m_scene.remove(this.m_subLight[k]);
	}
	this.m_scene.remove(this.m_light);
	this.m_scene = null;
};