MobsManager = function(dataGlobal, dataLevel){

    this.m_isManager = true;
	this.m_level;
	this.m_material;
	this.m_geometry = [];
	this.m_bloody;
	this.m_player;
	this.m_pathManager;
	this.m_interval;
	this.m_counter;
	this.m_globalCounter;
	this.c_initModel(dataGlobal, dataLevel);
	this.m_limit; 
};

MobsManager.prototype.c_initModel = function(dataGlobal,dataLevel){

	this.m_pathManager = new PathFinding();

	this.m_interval = 200;

	this.m_globalCounter = 0;

	this.m_counter = 0;

	this.m_limit = 200; 

	var dataMobs = dataGlobal.mobs;
	this.m_dataMobs = dataMobs;

	this.m_material = new Engine.MeshPhongMaterial( { map: new Engine.Texture( dataMobs[0].material.colorMap) } );

	this.m_bloody = new Engine.ObjMorphGeometry( "assets/obj/blood/splash.obj" );
	this.m_mapBloody = new Engine.Texture( "assets/textures/bloody.png" );

	for(var l=0,ll=dataMobs.length;l<ll;l++) {
		this.m_geometry.push(new Engine.ObjMorphGeometry( dataMobs[l].geometry )) ;
	}

};



MobsManager.prototype.c_update = function(t){

	var newmob,tile;

	this.m_globalCounter += t;

	if(this.m_counter > this.m_interval){
		this.m_counter = 0;
		this.m_pathManager.c_updateWalkable();
	}else{
		this.m_counter +=t; 
	}

	newmob = this.c_getNearestNewMob(this.m_player.m_n,this.m_player.m_m);

	if(newmob){

		 newmob = new Mob( newmob,this.m_dataMobs[newmob.id],this.m_material,this.m_geometry[newmob.id] );
		 newmob.c_setPlayer(this.m_player);
		 newmob.c_setPathManager(this.m_pathManager);
		 newmob.c_setLevel(this.m_level); 
		 newmob.c_setBlood(this.m_bloody,this.m_mapBloody);
		 return newmob;
	}
};



MobsManager.prototype.c_getMobOfTile = function(tile){
	if(tile){
		return tile.mobs.pop();
	}
};

MobsManager.prototype.c_getNearestNewMob = function(n,m){
	var newmob;
	newmob = this.c_getMobOfTile(this.m_level.c_IndexToTile(n-1,m-1));
	if(newmob) return newmob;
	newmob = this.c_getMobOfTile(this.m_level.c_IndexToTile(n-1,m));
	if(newmob) return newmob;
	newmob = this.c_getMobOfTile(this.m_level.c_IndexToTile(n-1,m+1));
	if(newmob) return newmob;
	newmob = this.c_getMobOfTile(this.m_level.c_IndexToTile(n+1,m-1));
	if(newmob) return newmob;
	newmob = this.c_getMobOfTile(this.m_level.c_IndexToTile(n+1,m));
	if(newmob) return newmob;
	newmob = this.c_getMobOfTile(this.m_level.c_IndexToTile(n+1,m+1));
	if(newmob) return newmob;
	newmob = this.c_getMobOfTile(this.m_level.c_IndexToTile(n,m-1));
	if(newmob) return newmob;
	newmob = this.c_getMobOfTile(this.m_level.c_IndexToTile(n,m+1));
	if(newmob) return newmob;
};


MobsManager.prototype.c_setLevel = function(level){

	this.m_level = level;
	this.m_matrixMap = level.m_matrixMap;

};

MobsManager.prototype.c_setPlayer = function(player){

	this.m_player = player;

};


MobsManager.prototype.c_setGameManager = function(manager){

	this.m_gameManager = manager;

};


