
Player = function(dataGlobal,dataLevel){

    /******************************************************/
	/**********************MODEL***************************/
	/******************************************************/

	/*****************variable deplacement*****************/
	this.m_position;
	this.m_lastPosition;
	this.m_direction;
	this.m_moveDirection;
	this.m_speed;
	this.m_n;
	this.m_m;
	/*****************variable d'affichage*****************/
	this.m_meshBody;
	this.m_meshLegs;
	this.m_meshHead;
	this.m_meshLight;
	this.m_material;
	this.m_scene;
	this.m_light;
	this.m_camera;
	this.m_cameraOffset;
	this.m_currentParticleGenerator;
	/*****************variable d'etat**********************/
	this.m_currentState;
	this.m_weapons;
	this.m_currentWeapon;
	this.m_isControlled;
	this.m_hp;
	this.m_hurtDuration;
	this.m_isHurt;
	this.m_lightPower;
	this.m_lightPowerMax;
	this.m_lightIntensity;
	/*****************variable d'animation*****************/
	this.m_animationsBody;
	this.m_animationsLegs;
	this.m_animationsLight;
	this.animationsHead;
	/*****************variable divers**********************/
	this.m_score;
	this.m_ctn0;
	this.m_ctn1;
	this.m_deltaLight;
	this.m_surfaceClick;
	this.m_level;
	this.m_timerHurt;
	this.m_win;
	this.m_hasShadow = true;
    /******************************************************/

	this.c_initModel(dataGlobal,dataLevel);
};

/**********************************************************************************/
/**********************CONTROLLER**************************************************/
/**********************************************************************************/

/**
Pour les variables du model
*/
Player.prototype.c_initModel = function(dataGlobal,dataLevel){

	var dataPlayer = dataGlobal.player;

	var dM = new dataManager();
	var previousLevel = dM.getPreviousLevel();

	var pos = dataLevel.spawnPlayer[Math.round(Math.random()*(dataLevel.spawnPlayer.length-1))];
	this.m_position = new Engine.Vector3(  pos[0],0,pos[1] );

	if(previousLevel){
		var doors = dataLevel.doors;
		for(var k=0,kl=doors.length;k<kl;k++){
			door = doors[k];
			if(door.levelId == previousLevel ){
				pos = this.m_position = new Engine.Vector3(  door.pos[0],0,door.pos[1]+2 );
				break;
			}

		}

	}

	//TODO

	this.m_light = new Engine.PointLight( 0xffffff, 1.0 , 7, [pos[0],3,pos[1]] );
	this.m_lightPower = 1;
	this.m_lightPowerMax = 30;
	this.m_direction = Math.to2KPI(dataPlayer.direction);
	this.m_moveDirection = Math.to2KPI(dataPlayer.direction);
	this.m_speed = dataPlayer.speed;

	this.m_deltaLight = dataPlayer.deltaLight;
	this.m_currentState = this.BEGIN;
	this.m_currentWeapon = 0;
	this.m_weapons = dataGlobal.weapons;
	this.m_isControlled = true;
	this.m_hp = data.hp||100;
	this.m_hurtDuration = dataPlayer.hurtDuration;
	this.m_animationsBody = dataPlayer.animationsBody;
	this.m_animationsLegs = dataPlayer.animationsLegs;
	this.animationsHead = dataPlayer.animationsHead;
	this.m_animationsLight = [{index:1,step:0},{index:0,step:1}];
	this.m_score = 0;
	this.m_ctn0 = 1;
	this.m_ctn1 = 0;
	this.m_deleted = false;
	this.m_lightIntensity = 0;
	this.m_surfaceClick = dataPlayer.surfaceClick;
	this.m_camera = new Engine.PerspectiveCamera( 45, null, 0.1, 100, null, dataPlayer.camera);
	this.m_cameraOffset = dataPlayer.camera;
	this.m_camera.lookAt(new Engine.Vector3(0,0,0));
	this.m_camera.position.x = this.m_position.x + this.m_cameraOffset[0];
	this.m_camera.position.z = this.m_position.z + this.m_cameraOffset[1]; 

	this.m_material = new Engine.MeshPhongMaterial( { 
				map: dataPlayer.material.colorMap?new Engine.Texture( dataPlayer.material.colorMap ):null,
				emissive: dataPlayer.material.emissive,
				specular: dataPlayer.material.specular,
				shininess: dataPlayer.material.shininess,
				lightMap: dataPlayer.material.lightMap?new Engine.Texture( dataPlayer.material.lightMap ):null,
				normalMap: dataPlayer.material.normalMap?new Engine.Texture( dataPlayer.material.normalMap ):null,
				transparent: dataPlayer.material.transparent,
				opacity: dataPlayer.material.opacity||1
			    } );

	this.m_meshBody = new Engine.MeshMorph( new Engine.ObjMorphGeometry( dataPlayer.geometryBody ), this.m_material, this.m_hasShadow );
	this.m_meshLegs = new Engine.MeshMorph( new Engine.ObjMorphGeometry( dataPlayer.geometryLegs ), this.m_material, this.m_hasShadow );
	this.m_meshHead = new Engine.MeshMorph( new Engine.ObjMorphGeometry( dataPlayer.geometryHead ), this.m_material, this.m_hasShadow );


	this.m_meshLight = new Engine.Mesh( new Engine.ObjGeometry( dataPlayer.geometryLight ), this.m_material );
	this.m_meshLight.position = new Engine.Vector3();
	this.m_meshBody.add(this.m_meshLight);


	this.m_script = this.m_scriptBegin();

};


/**
Pour créer et initialiser un générateur de particules
*/
Player.prototype.c_createParticleGenerator = function(data){

			var map = new Engine.Texture( data.bulletMap );
			
			var materialParticle = new Engine.ParticleSystemMaterial({color: 0xffffff, map: map});

			var particlesParams = {
				opacityBegin:1,opacityEnd:1,
				velocityBegin:0.02,velocityEnd:0.02,
				sizeBegin:data.size,sizeEnd:data.size,
				colorBegin:0xffffff,colorEnd:0xffffff,
				angleBegin: 0,angleEnd:0,
				spritSquareVariance:1,
				directionVariance:0,
				numberMax:40,
				frequency:data.frequency,
				duration:400
			};

			var generatorParams = {
				type:"point",
				numberBystep: 1
			};

			return new Engine.ParticlesGenerator( generatorParams,particlesParams,materialParticle/*, this.m_camera*/ );
};


/**
Mise à jour du modele
*/
Player.prototype.c_update = function(t){

	if(this.m_script){
		this.m_script(t);
	}else{ 
		this.c_readEvents(t);
		this.c_checkCollision();		
	}
	this.c_updateMesh(t);
	this.c_updateLight(t);
	this.c_checkSpike();

};



Player.prototype.c_checkSpike = function(){
	var spike;
	var p;
	for (var i=0,il=this.m_level.m_spike.length;i<il;i++) {

		spike = this.m_level.m_spike[i];
		spike.progress = 1;
		spike.keyB = 0;
		for (var k=0,kl=spike.clones.length;k<kl;k++) {
			p = spike.clones[k].elements;
			if( Math.abs(p[12]-this.m_position.x)<1&& Math.abs(p[14]-this.m_position.z)<1) {
				spike.keyB = {index:1,step:1000};
				spike.keyA = {index:1,step:1000};
				this.c_hurt();
			}
		}

	}; 

};


/**
Mise à jour en fonction des events
*/
Player.prototype.c_readEvents = function(t){

	if(this.m_currentState == this.DEAD )return;

	var key = Engine.keys;
	var mouse = Engine.mouse;

	if( key.UP ) {
		if( key.LEFT ) 	   this.c_move(Math.PI*5/4, t);
		else if(key.RIGHT) this.c_move(Math.PI*7/4, t);
		else 			   this.c_move(Math.PI*6/4, t);
	}else if ( key.DOWN ){ 
		if( key.LEFT )     this.c_move(Math.PI*3/4, t);
		else if(key.RIGHT) this.c_move(Math.PI*1/4, t);
		else			   this.c_move(Math.PI/2, t);
		
	} else if ( key.LEFT ) this.c_move(Math.PI, t);		
	 else if ( key.RIGHT ) this.c_move(0, t);
	 else this.c_static();


	if( mouse.downRight && !this.m_isHurt ){
		this.c_shoot(mouse.x,mouse.y);
	}else{
		this.c_straightLook(t);
	}
};

Player.prototype.c_shoot = function(x,y){

	var cam = this.m_scene.camera;
	var positionIn3DSpace = Math.intersectionLinePlane( cam.position, cam.vectorClick(x,y), this.m_surfaceClick );
	this.m_direction = positionIn3DSpace.sub( this.m_position).xzToAngle();

	/*             update state                   */
	if(this.m_currentState == this.WALK || this.m_currentState == this.SHOOTWALK ){
		this.m_currentState = this.SHOOTWALK;
	}else{
		this.m_currentState = this.SHOOT;
	}

};

Player.prototype.c_straightLook = function(t){
	this.m_direction += Math.subAngle(this.m_moveDirection, this.m_direction)*t*0.01;
	this.m_direction = Math.to2KPI(this.m_direction);
};


Player.prototype.c_static = function(){

	this.m_currentState = this.WAIT;	
	this.m_moveDirection = this.m_direction;
};

Player.prototype.c_move = function(angle,t){

	//this.m_moveDirection += Math.subAngle(angle, this.m_moveDirection)*t*0.05;
	//this.m_moveDirection = Math.to2KPI(this.m_moveDirection);
	this.m_moveDirection = Math.to2KPI(angle);

	this.m_position.x += this.m_speed * t * Math.cos(angle);
	this.m_position.z += this.m_speed * t * Math.sin(angle);

	this.m_n = Math.floor(this.m_position.x/this.m_level.m_tileSize);
	this.m_m = Math.floor(this.m_position.z/this.m_level.m_tileSize);

	this.m_camera.position.x = this.m_position.x + this.m_cameraOffset[0];
	this.m_camera.position.z = this.m_position.z + this.m_cameraOffset[1]; 
	//this.m_light.position.x = this.m_position.x+4*Math.cos(this.m_direction);
	//this.m_light.position.z = this.m_position.z+4*Math.sin(this.m_direction);

	this.m_currentState = this.WALK;

	this.m_level.c_updateLight(this.m_position.x,this.m_position.z-3);

};


Player.prototype.c_hurt = function(val){

	if(!this.m_isHurt) {
		this.m_isHurt = true;
		this.m_hp = 0;
		this.c_dead();
	}

};


Player.prototype.c_takeOil = function(id){

	var tab = ['assets/sound/torche_3.mp3','assets/sound/torche.mp3','assets/sound/torche9.mp3'];

	sm.play(tab[Math.floor(Math.random()*2.99)],0);
	this.m_lightPower = 1;
	this.m_lightIntensity = 1;
};

Player.prototype.c_updateLight = function(t){
	this.m_ctn1 +=t;
	this.m_light.distance = 2*(this.m_lightPower/6+Math.pow(this.m_lightPower,0.5)/6)*this.m_lightPowerMax+0.1*Math.cos(this.m_ctn1/50);
	this.m_light.color.r = 1+0.01*Math.cos(this.m_ctn1/45)+this.m_lightIntensity;
	this.m_light.color.g = this.m_light.color.r;
	this.m_light.color.b = this.m_light.color.b;
	console.log(this.m_light.intensity)
	this.m_lightPower -= this.m_deltaLight*t;
	//if(this.m_lightPower < 0.1)this.m_lightPower=0.1;
	if(this.m_lightPower < 0.01 ){
		this.m_lightPower=0.01;
		if(!this.m_flagDark){
			this.m_flagDark = true;
			var that = this;
			this.m_timerDark = setTimeout(function(){
				that.c_hurt();
			},2000);
		}
	}


	this.m_lightIntensity += (0-this.m_lightIntensity)*t*0.02;



	//this.m_lightPower;
	//this.m_lightPowerMax;
};



Player.prototype.c_dead = function(){
	this.m_light.distance = 3;
	this.m_currentState = this.DEAD;
};

Player.prototype.c_killMob = function(score){
	this.m_score += score;
};

Player.prototype.c_getTreasure = function(){
	this.m_hasTreasure = true;
	dM = new dataManager();
    dM.updateHasTreasure(true);
    if(this.m_level.m_meshTreasure)
    this.m_level.m_meshTreasure.visible = false;
}


Player.prototype.c_win = function(){
		this.m_win = true;
		this.m_script = this.m_scriptWin();
}

Player.prototype.c_lose = function(){
	this.m_script = this.m_scriptLose();
}
/**********************************************************************************/
/**********************CONTROLLER GESTION DES ANIMATIONS***************************/
/**********************************************************************************/


Player.prototype.c_updateMesh = function(t){
	this.c_updateMeshBody(t);
	this.c_updateMeshLegs(t);
	this.c_updateMeshHead(t);
	this.c_updateMeshWeapon(t);


	var light = this.m_level.m_light;
	var camShadow = this.m_level.m_cameraShadow;
	light.position.x = this.m_position.x + this.m_cameraOffset[0]+5;
	light.position.z = this.m_position.z + this.m_cameraOffset[1];
	camShadow.position.x = this.m_position.x;
	camShadow.position.z = this.m_position.z;
	this.m_scene._lightsNeedUpdate = true;
};


Player.prototype.c_updateMeshLegs = function(t){
	var pi = Math.PI;
	var e = Math.subAngle(this.m_moveDirection, this.m_direction);
	var em = Math.abs(e);
	var back,straff,left,right;
	var cs = this.m_currentState;

	if( em > pi/2  ) back = true;
	if( em >  pi/4 && em < 3*pi/4 ) straff = true;
	if( e >  0 ) right = true;
	if( e <=  0 ) left = true;

	
	if ( cs == this.WALK || cs == this.SHOOTWALK) {
		var targetDirection;
		if(straff){
			if(left){
				this.m_meshLegs.setAnimation(this.m_animationsLegs.straffLeft,500,true);
				targetDirection = -this.m_moveDirection-pi/2;
			}else{
				this.m_meshLegs.setAnimation(this.m_animationsLegs.straffRight,500,true);
				targetDirection = -this.m_moveDirection+pi/2;
			}
		}else{
			if(back){
				this.m_meshLegs.setAnimation(this.m_animationsLegs.walkBack,500,true);
				targetDirection = -this.m_moveDirection+pi;
			}else{
				this.m_meshLegs.setAnimation(this.m_animationsLegs.walkFront,500,true);
				targetDirection = -this.m_moveDirection;
			}
		}

		/*if(cs != this.SHOOTWALK){
			var eTarget = Math.subAngle(targetDirection, this.m_meshBody.rotation.y);
			this.m_meshBody.rotation.y +=  eTarget*t*0.005;
		}else{
			this.m_meshBody.rotation.y = -this.m_direction;
		}*/

		this.m_meshLegs.rotation.y = -this.m_direction;
	}else{
		if( cs == this.DEAD) 
				this.m_meshLegs.setAnimation(this.m_animationsLegs.lose,1000,false);
		else if( cs == this.VICTORY ){
				this.m_meshLegs.setAnimation(this.m_animationsLegs.win,1000,false);
		}else if(em>0.01){
			this.m_meshLegs.setAnimation(this.m_animationsLegs.straffRotate,500,true);
		}else{
			this.m_meshLegs.setAnimation(this.m_animationsLegs.wait,500,true);
		}
		this.m_meshLegs.rotation.y = -this.m_direction;
	}

	this.m_meshBody.rotation.y = -this.m_direction;

	this.m_meshLegs.position = this.m_position;

	this.m_meshLegs.update(t);
};

Player.prototype.c_updateMeshBody = function(t){

	this.m_meshBody.position = this.m_position;
	//this.m_meshBody.rotation.y = -this.m_direction;
		
	switch(this.m_currentState){

		case this.WAIT :
				console.log()
				this.m_meshBody.setAnimation(this.m_animationsBody.wait,2000,true);
		break;
		case this.WALK :
				this.m_meshBody.setAnimation(this.m_animationsBody.walk,500,true);
		break;
		case this.SHOOT :
			if(this.m_meshBody.keys!=this.m_animationsBody.shoot){
				this.m_meshBody.running = false;
				this.m_meshBody.keys  = this.m_animationsBody.shoot;
				this.m_meshBody.keyA = this.m_animationsBody.shoot[1];
				this.m_meshBody.keyB = this.m_animationsBody.shoot[0];
			}
		break;
		case this.SHOOTWALK :
				this.m_meshBody.setAnimation(this.m_animationsBody.shoot,200,true);	
		break;
		case this.VICTORY :
				this.m_meshBody.setAnimation(this.m_animationsBody.win,1000,false);
		break;
		case this.BEGIN :
				this.m_meshBody.setAnimation(this.m_animationsBody.wait,1000,false);	
		break;
		case this.DEAD :
				this.m_meshBody.setAnimation(this.m_animationsBody.lose,1000,false);	
		break;
		case this.GETWEAPON :
		break; 
	} 

	this.m_meshBody.update(t);
};

Player.prototype.c_updateMeshHead = function(t){
	this.m_meshHead.position.x = this.m_position.x;
	this.m_meshHead.position.z = this.m_position.z;
	this.m_meshHead.rotation.y = -this.m_direction;

	switch(this.m_currentState){

		case this.WAIT :
				this.m_meshHead.setAnimation(this.animationsHead.static,2000,true);
		break;
		case this.WALK :
				this.m_meshHead.setAnimation(this.animationsHead.walk,500,true);
		break;
		case this.SHOOTWALK :
				this.m_meshHead.setAnimation(this.animationsHead.walk,500,true);
		break;
		case this.DEAD :
				this.m_meshHead.setAnimation(this.animationsHead.lose,1000,false);	
		break;
		default :
			this.m_meshHead.setAnimation(this.animationsHead.static,500,true);
		break; 
	} 

	this.m_meshHead.update(t);

};

Player.prototype.c_updateMeshWeapon = function(t){
	
	var m_meshLight =	this.m_meshLight;

	if(this.m_currentState == this.SHOOT || this.m_currentState == this.SHOOTWALK){
		m_meshLight.position.x = 0.8;
		m_meshLight.position.y = 1.3;
		m_meshLight.position.z = -0.2;
		this.m_light.position.x = this.m_position.x+2*Math.cos(this.m_direction);
		this.m_light.position.z = this.m_position.z+2*Math.sin(this.m_direction);
	}else if(this.m_currentState == this.DEAD){
		m_meshLight.position.x = 0.3;
		m_meshLight.position.y = 0.2;
		m_meshLight.position.z = -0.5;
	}else{
		m_meshLight.position.x = 0.3;
		m_meshLight.position.y = 1.0;
		m_meshLight.position.z = -0.5;
		this.m_light.position.x = this.m_position.x+1*Math.cos(this.m_direction);
		this.m_light.position.z = this.m_position.z+1*Math.sin(this.m_direction);
	}

};


Player.prototype.c_setLevel = function(level){

	this.m_level = level;

};



Player.prototype.c_checkCollision = function(){

	if(this.m_level.c_checkCollision(this.m_position,0.2)){
		this.m_position = this.m_lastPosition.clone();
	}else{
		this.m_lastPosition = this.m_position.clone();
	}
};


/**********************************************************************************/
/**********************CONTROLLER SRIPT********************************************/
/**********************************************************************************/

Player.prototype.m_scriptBegin = function(){

	sm.play('assets/sound/torche_3.mp3',0);

	var self = this;
	var ctn = 0;
	return function(t){
		self.m_currentState = self.BEGIN;
		ctn+=t;
		if(ctn>2000){
			self.m_currentState = self.WAIT;
			self.m_script = null;
		}
	};
};

Player.prototype.m_scriptWin = function(){
	var self = this;
	var dM = new dataManager();
	dM.updateHasTreasure(false);	
	return function(t){
		self.m_currentState = self.VICTORY;
	};
};

Player.prototype.m_scriptLose = function(){
	var self = this;
	var dM = new dataManager();
	dM.updateHasTreasure(false);	
	return function(t){
		self.m_currentState = self.DEAD;
	};
};


/**********************************************************************************/
/**********************CONTROLLER PRIMAIRE*****************************************/
/**********************************************************************************/

Player.prototype.c_getPosition = function() {
	return this.m_position;
};

Player.prototype.c_setPosition = function(position) {
	this.m_position = position;
};

Player.prototype.add = function(scene) {
	scene.add(this.m_meshBody);
	scene.add(this.m_meshLegs); 
	scene.add(this.m_meshHead); 
	scene.add( this.m_camera );
	scene.add(this.m_light);

	this.m_scene = scene; 
};

Player.prototype.remove = function(scene) {
	scene.remove(this.m_meshBody);
	scene.remove(this.m_meshLegs);
	scene.remove(this.m_meshHead);
	scene.remove(this.m_light);
	this.m_scene = null;
};

Player.prototype.WAIT = 1;
Player.prototype.WALK = 2;
Player.prototype.SHOOT = 3;
Player.prototype.SHOOTWALK = 4;
Player.prototype.VICTORY = 7;
Player.prototype.BEGIN = 8;
Player.prototype.DEAD = 9;
Player.prototype.GETWEAPON = 10;
