ControllerManager = function(){

	this.elements = [];
	this.managers = [];
	this.view;
	this.elements = [];

};

ControllerManager.prototype.launch = function(view){
	this.view.start();
};

ControllerManager.prototype.setView = function(view){
	this.view = view;
};


ControllerManager.prototype.postStart = function(){
	for(var i=0,il=this.elements.length;i<il;i++){
		if(this.elements[i].c_ready){
			this.elements[i].c_ready();
		}
	}
};

ControllerManager.prototype.add = function(element){
	
		if(element.m_isManager){
			this.managers.push(element);
		}else{
			this.elements.push(element);
			this.view.add(element);
		}
};

ControllerManager.prototype.remove = function(element){
	this.elements.remove(element);
	this.view.remove(element);
};


ControllerManager.prototype.update = function(t){

	var i,il;

	for(i=0,il=this.elements.length;i<il;i++){
			
			this.elements[i].c_update( t );
			if( this.elements[i] && this.elements[i].m_deleted ){
				this.remove(this.elements[i]);
				i--;il--;
			}
	}


	for(i=0,il=this.managers.length;i<il;i++){

		var newElement =  this.managers[i].c_update( t );
		if(newElement){
			this.add(newElement);	
		}

	}

};
;	/*var d = dataGlobal.level.tileSize;
	var spawner;
	for(var i=0,il=dataLevel.spawnMob.length;i<il;i++) {
			this.m_spawn[i] = [];
		for(var k=0,kl=dataLevel.spawnMob[i].length;k<kl;k++){
			spawner = dataLevel.spawnMob[i][k];
			this.m_spawn[i][k] = {x:spawner.pos[0],z:spawner.pos[1],d:d,rot:spawner.rot,ctn:1000,timer:0,cycle:200,delay:spawner.delay};
		}
	}*/


DoorManager = function(dataGlobal){

	this.m_isManager = true;
	this.m_player;
	this.m_doors = [];
	this.c_initModel(dataGlobal);
};

DoorManager.prototype.c_initModel = function(dataGlobal){
	this.m_doors = dataGlobal.doors;
}


DoorManager.prototype.c_update = function(t){
	var pos = this.m_player.m_position;
	var pdoor;
	for(var k=0,kl=this.m_doors.length;k<kl;k++){
		pdoor = this.m_doors[k].pos;
		if(Math.abs(pos.x-pdoor[0])<1&&Math.abs(pos.z-pdoor[1])<1){

			var dM = new dataManager();
			dM.updatePreviousLevel(this.m_player.m_level.m_name);	
			this.c_loadLevel(this.m_doors[k]);
		}
	}
}



DoorManager.prototype.c_loadLevel = function(door){
	reloadMap(door.levelId);
};



DoorManager.prototype.c_setPlayer = function(player){

	this.m_player = player;

};

;
GameManager = function(dataLevel){

   this.m_targetPosition;
   this.m_beginPosition;
   this.m_targetScore;
   this.m_targetTimer;
   this.m_targetFailure;
   this.m_timeout;
   this.m_player;

   this.m_gameFinished;

   this.m_watchedScore = {value:null};
   this.m_watchedHP = {value:null};
   this.m_watchedVictory = {value:null};
   this.m_watchedLoose = {value:null};
   this.m_watchedOil = {value:null};

   this.m_targetMob;
   this.m_counter;
   this.m_failure;

   this.m_modeTP;
   this.m_modeSW;
   this.m_modeT;
   this.m_modeS;
   this.m_modeTM;

   this.c_initModel( dataLevel);


};

GameManager.prototype.c_initModel = function(data){

 	this.m_isManager = true;
 	if(data.targetPlayer){
			this.m_targetPosition = new Engine.Vector3(data.targetPlayer[0],0,data.targetPlayer[1]);
	}
	if(data.beginPlayer&&data.beginPlayer.length)
	this.m_beginPosition = new Engine.Vector3(data.beginPlayer[0],0,data.beginPlayer[1]);

	this.m_gameFinished = false;


	this.m_targetFailure = 5;
	this.m_targetTimer = data.timeTarget;
	this.m_targetScore = data.scoreTarget;

	this.m_timeout = data.timeout;

	this.m_failure = 0;
	this.m_counter = 0;

};

GameManager.prototype.c_setPlayer = function(player){
	 this.m_player = player ;
};


GameManager.prototype.c_mobWin = function(mob){
	this.m_gameFinished = true
	this.m_player.c_lose();

};

GameManager.prototype.c_playerWin = function(){
	this.m_gameFinished = true
	this.m_player.c_win();
};


GameManager.prototype.c_playerLose = function(mob){
	this.m_gameFinished = true;
	this.m_player.c_lose();
};



GameManager.prototype.c_update = function(t){

	if(this.m_gameFinished)return;

	this.c_checkTargetPosition();
	this.c_checkBeginPosition();
	this.c_checkPlayerLife();
	this.c_checkPlayerScore();
	this.c_checkTimeout();
	this.c_checkOil();

	this.m_counter += t; 

};




GameManager.prototype.c_checkOil = function(){

	this.m_watchedOil.value = this.m_player.m_currentOil;
};


GameManager.prototype.c_checkTargetPosition = function(){
	if(this.m_player.m_hasTreasure || !this.m_targetPosition)return;

	if(this.m_player.m_position.distanceTo(this.m_targetPosition)<2){
		this.m_player.c_getTreasure();
		sm.play('assets/sound/tresor.mp3',0);

	}
	
	
};


GameManager.prototype.c_checkBeginPosition = function(){
	if(this.m_beginPosition)
	if(this.m_player.m_position.distanceTo(this.m_beginPosition)<2){
		dM = new dataManager();
    	var treasure = dM.getHasTreasure(true);	
		if(treasure){
			this.c_playerWin();
			this.m_watchedVictory.value = true;
		}
	}
	
};


GameManager.prototype.c_checkPlayerLife = function(){
	this.m_watchedHP.value = this.m_player.m_hp;
	if(this.m_player.m_hp<1){
		this.c_playerLose();
		this.m_watchedLoose.value = true;
		sm.play('assets/sound/gameover.mp3',0);
	}
	
};

GameManager.prototype.c_checkPlayerScore = function(){
	this.m_watchedScore.value = this.m_player.m_score;
	if(this.m_targetScore && this.m_player.m_score>=this.m_targetScore){
		this.c_playerWin();
		this.m_watchedVictory.value = true;
	}
	
};


GameManager.prototype.c_checkTimeout = function(){

	if(this.m_timeout && this.m_counter>=this.m_timeout){
		this.c_playerLose();
		this.m_watchedLoose.value = true;
	}
	
};

GameManager.prototype.c_MobTakeTarget = function(){
	this.m_failure++;
	if(this.m_failure>this.m_targetFailure){
		this.c_mobWin();
		this.m_watchedLoose.value = true;
	}

};


GameManager.prototype.c_checkTargetTimer = function(){

	if(this.m_targetTimer && this.m_counter>=this.m_targetTimer){
		this.c_playerWin();
		this.m_watchedVictory = {value:true};
	}
	
};





;
Level = function(dataGlobal,dataWorld){

    /******************************************************/
	/**********************MODEL***************************/
	/******************************************************/

	this.m_tileSize;
	this.m_world;
	this.m_scene;
	this.m_material;
	this.m_light;
	this.m_subLight = [];
	this.m_meshTiles = [];
	this.m_meshElements = [];
	this.m_matrixMap = [];
	this.m_matrixBlock = [];
	this.m_matrixDynamicBlock = [];
	this.m_dynamicBlocks = [];
	this.m_N;
	this.m_M;
	this.m_sizeN;
	this.m_sizeM;
	this.m_destructor;

	this.m_ctn;

	this.m_blockSize;
	this.m_blockFactor;

	this.m_hasShadow = true;
	this.m_cameraShadow;
	this.m_meshTreasure;
	this.m_Spike = [];
	this.m_spike = [];

	this.c_initModel(dataGlobal,dataWorld);
};

Level.prototype.c_initModel = function(dataGlobal,dataWorld){

	this.m_tileSize = dataGlobal.tileSize;
	this.m_world = dataWorld.model;
	this.m_N = dataGlobal.nWidth;
	this.m_M = dataGlobal.nHeight;
	this.m_sizeN = this.m_N * this.m_tileSize;
	this.m_sizeM = this.m_M * this.m_tileSize;
	this.m_name = dataWorld.name;
	var i,il;

	this.m_blockFactor = 5;
	this.m_blockSize = this.m_tileSize/this.m_blockFactor;
	this.m_halfblock =  this.m_blockSize/2;

	this.m_destructor = dataWorld.destructor;



	this.m_ctn = 0;


	//creation de la matrixMap
	for(i=0; i<this.m_N; i++){
		this.m_matrixMap[i] = [];
		for(var j=0; j<this.m_M; j++){
			this.m_matrixMap[i][j] = null;
		}
	}

	this.m_material = new Engine.MeshPhongMaterial( { map: new Engine.Texture( dataGlobal.tilesMap),transparent:true, shininess:0,normalMap: new Engine.Texture( dataGlobal.tilesNormal) } );

	this.m_material2 = new Engine.MeshPhongMaterial( { map: new Engine.Texture( "assets/textures/light.jpg"), lightMap : new Engine.Texture( "assets/textures/lightlum.jpg")} );

	this.m_material3 = new Engine.MeshPhongMaterial( { map: new Engine.Texture( "assets/textures/blood.png"),transparent:true});

	//this.m_material4 = new Engine.MeshPhongMaterial( { map: new Engine.Texture( dataGlobal.tilesMap),transparent:true,shininess:10 } );

	var geoTiles = [];
	for(i=0,il=dataGlobal.tiles.length;i<il;i++) {
		geoTiles.push(new Engine.ObjGeometry( dataGlobal.tiles[i] )) ;
	}
	var geoElements = [];
	for(i=0,il=dataGlobal.elements.length;i<il;i++) {

		if(i==22){
			geoElements.push(new Engine.ObjGeometry( dataGlobal.elements[i] ));
		}else
		geoElements.push( new Engine.ObjGeometry( dataGlobal.elements[i] ));
		/*if ( dataGlobal.elements[i].index == 0  ) {
			 this.m_Spike.push( {dataGlobal.elements[i].x, dataGlobal.elements[i].y})
		}*/
	}

	var world = this.m_world;
	var d = this.m_tileSize;


	for(i=0, il=world.length; i<il;i++){

		var block = world[i];

		if(!this.m_meshTiles[block.id]){
			this.m_meshTiles[block.id] = new Engine.Mesh( geoTiles[block.id], this.m_material, false, this.m_hasShadow );

		}

		var positionX = block.pos[0];
		var positionY = 0;
		var positionZ = block.pos[1];

		var nm = this.c_positionToIndex(positionX,positionZ);

		var tile = this.m_matrixMap[nm[0]][nm[1]] = {id:block.id,geo:geoTiles[block.id],elements:[],mobs:block.mob||[],oils:block.wea||[],destructor:false};

		this.m_meshTiles[block.id].addClone(positionX,positionY,positionZ,0,block.rot*Math.PI,0,0,0,block.symmetry?-1:1,1);	
		for(var k=0, kl=block.ele.length; k<kl;k++){	
			var element = block.ele[k];
			if(!this.m_meshElements[element.id]){

				if(element.id==9){
					this.m_meshElements[element.id] = new Engine.Mesh( geoElements[element.id], this.m_material2, this.m_hasShadow );
				}else if(element.id==11){
					this.m_meshElements[element.id] = new Engine.Mesh( geoElements[element.id], this.m_material3 );
				}else if(element.id==21){
					this.m_meshElements[element.id] = new Engine.Mesh( geoElements[element.id], this.m_material, this.m_hasShadow );
					this.m_spike.push(this.m_meshElements[element.id]);
				}else if(element.id==22){
					this.m_meshElements[element.id] = new Engine.Mesh( geoElements[element.id], this.m_material );
					this.m_spike.push(this.m_meshElements[element.id]);
					//this.m_meshElements[element.id].setAnimation([{"index": 1,"step": 0},{"index": 1,"step": 1}],600,false);

				}else{
					this.m_meshElements[element.id] = new Engine.Mesh( geoElements[element.id], this.m_material, this.m_hasShadow );
				}


			}
			var elepos = new Engine.Vector3(element.pos[0],0,element.pos[1]);
			this.m_meshElements[element.id].addClone(elepos.x,elepos.y,elepos.z,0,element.rot*Math.PI,0,0,0,element.sym?-1:1,1);	
		}
	}

	//init destructor

	for(i=0, il=this.m_destructor.length; i<il;i++){
		 this.c_positionToTile(this.m_destructor[i][0],this.m_destructor[i][1]).destructor = true;
	}


	for(i=0,il=dataWorld.lights.length;i<il;i++ ){
		var l = dataWorld.lights[i];
		var newLight = new Engine.PointLight( l.color, 1.0 , l.radius, l.pos );
		this.m_subLight.push(newLight);
	}

	dM = new dataManager();
	if(dataWorld.beginPlayer&&dataWorld.beginPlayer.length&&!dM.getHasTreasure()){
		this.m_meshTreasure = new Engine.Mesh(  new Engine.ObjGeometry( 'assets/obj/elements/chest.obj' ), this.m_material );
		this.m_meshTreasure.position = new Engine.Vector3(dataWorld.targetPlayer[0],0,dataWorld.targetPlayer[1]);
		this.m_meshTreasure.rotation.y = Math.PI/2;
	}
	
};

Level.prototype.c_ready = function(){

	var i,il;

	for(i=0, il=this.m_meshTiles.length; i<il;i++){
		if(this.m_meshTiles[i]){
			this.m_meshTiles[i].geometry.computeBoundingBox();
			if(this.m_meshTiles[i].geometry.boundingBox.max.y>1){
				
				this.m_meshTiles[i].geometry.collision = true;
			}else{
				this.m_meshTiles[i].geometry.collision = false;
			}
		}
	}
	for(i=0, il=this.m_meshElements.length; i<il;i++){
		if(this.m_meshElements[i]){
			this.m_meshElements[i].geometry.computeBoundingBox();
			if(this.m_meshElements[i].geometry.boundingBox.max.y>0.1){
				this.m_meshElements[i].geometry.collision = true;
			}else{
				this.m_meshElements[i].geometry.collision = false;
			}
		}
	}



	//on recupere les elements pouvant provoquer des collision;
	var tile;
	for(i=0; i<this.m_N; i++){
		for(var j=0; j<this.m_M; j++){
			tile = this.m_matrixMap[i][j];
			if(tile){
				if(this.m_meshTiles[tile.id].geometry.collision){
					tile.collision = true;
				}else{
					tile.collision = false;
				}
			}
		}
	}

	var world = this.m_world;

	for(i=0, il=world.length; i<il;i++){

		var block = world[i];
		
		var positionX = block.pos[0];
		var positionY = 0;
		var positionZ = block.pos[1];
		tile = this.c_positionToTile(positionX,positionZ);

		for(var k=0, kl=block.ele.length; k<kl;k++){
			var element = block.ele[k];
			var elementPosition = new Engine.Vector3(element.pos[0],0,element.pos[1]);
			if(this.m_meshElements[element.id].geometry.collision){
				tile.elements.push({ 
					id:element.id,
					mesh:this.m_meshElements[element.id].geometry,
					position:elementPosition,
					boundingBox:this.m_meshElements[element.id].geometry.boundingBox.clone().translate(elementPosition)
					});
			}
		}

	}
	
	this.c_generateCollisionBlocks();
};

Level.prototype.c_generateCollisionBlocks = function(){

	var x,z,box, tile,closed;
	var width = this.m_N * this.m_blockFactor;
    var height =  this.m_M * this.m_blockFactor;
    var f = this.m_blockFactor;
	var i,j;

	this.m_matrixBlock = new Array(width);
	for (i = 0; i < width; ++i) {
		this.m_matrixBlock[i] = new Array(height);
		for (j = 0; j < height; ++j) {

			x = i*this.m_blockSize;
			z = j*this.m_blockSize;
			
			tile = this.m_matrixMap[Math.floor(i/f)][Math.floor(j/f)];
			box = new Engine.Box3( new Engine.Vector3(x,-1,z),new Engine.Vector3(x+this.m_blockSize,10,z+this.m_blockSize));

			if(!tile || tile.collision){
				this.m_matrixBlock[i][j] = true;
			}else if( this.c_checkCollisionElementsToBox(box,tile) ){
				this.m_matrixBlock[i][j] = true;
			}else{
				this.m_matrixBlock[i][j] = false;
			}
		}

	}



	this.m_matrixDynamicBlock = new Array(width);
	for (i = 0; i < width; ++i) {
            this.m_matrixDynamicBlock[i] = new Array(height);
    }

};

Level.prototype.c_generateCollisionDynamicBlocks = function(){

  		var width = this.m_N * this.m_blockFactor;
        var height =  this.m_M * this.m_blockFactor;
        var db = this.m_dynamicBlocks;
        var blocks = this.m_matrixDynamicBlock;
        var i, j;
        var pos;
        i = width;
        while(i--) {
        	j = height;
            while(j--) {
                blocks[i][j] = false;
            }
        }
        i = db.length;
		while(i--) {
				pos = db[i].m_position;
				blocks[Math.floor(pos.x/this.m_blockSize)][Math.floor(pos.z/this.m_blockSize)] = true;
		}
};

//block de collision pour le pathfinding

Level.prototype.c_getBlockByIndex = function( n,m ) {
	if(this.m_matrixBlock[n][m]){
		return true;
	}else if(this.m_matrixDynamicBlock[n][m]){
		return true;
	}else{
		return false;
	}
};

//index de la matrix des block pathfinding
Level.prototype.c_positionToIndexBlock = function( v1,v2 ) {
	var nt = Math.floor(v1/this.m_blockSize);
	var mt = Math.floor(v2/this.m_blockSize);
	return [n,m];
};

Level.prototype.c_positionToIndex = function(v1,v2){
	var n = Math.floor(v1/this.m_tileSize);
	var m = Math.floor(v2/this.m_tileSize);
	return [n,m];
};

Level.prototype.c_IndexToPosition = function(n,m){
	var x = n * this.m_tileSize;
	var z = m * this.m_tileSize;
	return new Engine.Vector3(x,0,z);
};

Level.prototype.c_positionToTile = function(v1,v2){
	var n = Math.floor(v1/this.m_tileSize);
	var m = Math.floor(v2/this.m_tileSize);
	if(this.m_matrixMap[ n ]){
		return this.m_matrixMap[ n ][ m ];
	}
};

Level.prototype.c_IndexToTile = function(n,m){
	if(this.m_matrixMap[ n ]){
		return this.m_matrixMap[ n ][ m ];
	}
};

Level.prototype.c_addDynamicCollisionBlock = function(block){
	this.m_dynamicBlocks.push(block);
};

Level.prototype.c_removeDynamicCollisionBlock = function(block){
	var db = this.m_dynamicBlocks;
	for (var i = db.length - 1; i >= 0; i--) {
		if(db[i]==block){
			db.splice(i,1);
			return;
		}
	}
};



Level.prototype.c_update = function(t){

     this.m_light.color.r =1;
     this.m_light.color.g =1;
     this.m_light.color.b =1;



    /* for(var i=0,il=this.m_spike.length;i<il;i++){
     	if(this.m_spike[i].update){
     		this.m_spike[i].update(t);
     	}
     }*/



	//if(this.m_ctn>10){
		//this.m_ctn = 0;
		this.c_generateCollisionDynamicBlocks();
	//}else{
	//	this.m_ctn+=t;
	//}
	
};


/*Level.prototype.c_checkCollision = function(position,radius){
	var n = Math.floor(position.x/this.m_tileSize);
	var m = Math.floor(position.z/this.m_tileSize);
	var tile = this.m_matrixMap[ n ][ m ];
    var i;
	var collision = false;

	if(tile){
		if(tile.collision){
			collision = true;
		}else{
			i = tile.elements.length;
			while(i--){
				if( tile.elements[i].boundingBox.distanceToPoint(position)<radius){
					collision = true;
					break;
				}
			}
		}
	}else{
		collision = true;
	}
	return collision;

}*/



Level.prototype.c_checkCollision = function(position,radius){
	var n = Math.floor(position.x/this.m_tileSize);
	var m = Math.floor(position.z/this.m_tileSize);
	var row = this.m_matrixMap[ n ];
	var tile;
	var i;
	if(!row) return true;

	tile = row[ m ];

	if(tile&&!tile.collision){
			i = tile.elements.length;
			while(i--){
				if( tile.elements[i].boundingBox.distanceToPoint(position)<radius){
					return true;
				}
			}
	}else{
		return true;
	}
	return false;

};

Level.prototype.c_checkCollisionElementsToBox = function(box,tile){
	var i = tile.elements.length;
	while(i--){
		if( box.isIntersectionBox( tile.elements[i].boundingBox)){
			return true;
		}
	}
	return false;
};


Level.prototype.c_updateLight = function(x,z){
	var l;
	for(k=0, kl=this.m_subLight.length; k<kl;k++){
		l = this.m_subLight[k];

		if(Math.abs(x-l.position.x)<25&&Math.abs(z-l.position.z)<25){
			l.intensity=1;
		}else{
			l.intensity=0;
		}
		this.m_scene._lightsNeedUpdate = true;

	}
}


/*
Level.prototype.c_checkIntersection = function(px1,pz1,px2,pz2,radius){

	var collision = false;d
	var n1 = Math.floor(px2/this.m_tileSize);
	var m1 = Math.floor(pz2/this.m_tileSize);
	var tile = this.m_matrixMap[ n1 ][ m1 ];

	var v,b;
	//Tile de destination bloquee ?
	if(tile.collision) { 
		return true;
	}

	//collisions ELEMENTS de la tile arrivee
	//return true or conntinue
	if(this.checkIntersectionElements(px1,pz1,px2,pz2,tile)){
		return true;
	}

	var n2 = Math.floor(px1/this.m_tileSize);
	var m2 = Math.floor(pz1/this.m_tileSize);

	if(n1 == n2 && m1 == m2 ){ //meme tile  depart==arrivee

		return false;

	}else {

		tile = this.m_matrixMap[ n2 ][ m2 ];

		if(this.checkIntersectionElements(px1,pz1,px2,pz2,tile)){
			return true;
		}
		//collisions ELEMENTS de la tile de depart	
		//return true or conntinue

		if ( n1 == n2  || m1 == m2) { //tile haut ou bas ou droite ou gauche

			return false
		
		}else{ // on vient d'un tile diagonal, il est possible de traverser un tile entre le depart et la destination


			var n3,m3, n4,m4, minx,minz, a;

			if(n1>n2){ //block de gauche
				if(m1>m2){ //block du bas //G B
					n3 = n1-1; m3=m1; 
					n4 = n1; m4=m1-1; 
				}else if (m1<m2){ //block du haut // G H
					n3 = n1-1; m3=m1; 
					n4 = n1; m4=m1+1; 
				}

			}else if(n1<px2) { //block de droite 
				if(m1>m2){ //block du bas // D B
					n3 = n1+1; m3=m1; 
					n4 = n1; m4=m1-1; 	

				}else if (m1<m2){ //block du haut  // D H
					n3 = n1+1; m3=m1; 
					Math.intersectionSegBox(px1,pz1,px2,pz2,);
					n4 = n1; m4=m1+1; 
				}

			}

			minx =  (n3)*this.m_tileSize; 
			minz =  (m3)*this.m_tileSize;
			a = Math.intersectionSegBox(px1,pz1,px2,pz2,minx,minx+this.m_tileSize,minz,minz+this.m_tileSize);
			if(a){
				tile = this.m_matrixMap[ n3 ][ m3 ];
				if(tile.collision) { 
					return true;
				}else{
					//collisions ELEMENTS de la tile traverse
					//return true or false
					return this.checkIntersectionElements(px1,pz1,px2,pz2,tile);
				}
			}

			minx =  (n4)*this.m_tileSize; 
			minz =  (m4)*this.m_tileSize;
			a = Math.intersectionSegBox(px1,pz1,px2,pz2,minx,minx+this.m_tileSize,minz,minz+this.m_tileSize);
			if(a){
				tile = this.m_matrixMap[ n4 ][ m4 ];
				if(tile.collision) { 
					return true;
				}else{
					//collisions ELEMENTS de la tile traverse
					//return true or false	
					return this.checkIntersectionElements(px1,pz1,px2,pz2,tile);
				}
			}

		}

	}

}

Level.prototype.c_checkIntersectionElements = function(px1,pz1,px2,pz2,tile){
	var element,pos,box, a;
	for(var i=0, il=tile.elements.length; i<il;i++){

		element = tile.elements[i];
		pos = element.position;
		box = element.boundingBox;

		a = Math.intersectionSegBox(px1,pz1,px2,pz2, pos.x+box.xmin,pos.x+box.xmax,pos.z+box.zmin,pos.z+box.zmax);

		if(a)
			return true;
		else
			return false;
	}

}*/





/**********************************************************************************/
/**********************CONTROLLER PRIMAIRE*****************************************/
/**********************************************************************************/

Level.prototype.add = function(scene) {
	var k=0, kl;
	this.m_scene = scene;

	this.m_light = new Engine.PointLight( 0xffffff, 0.1 , 40, [7,15,8] );

	this.m_scene.add(this.m_light);


	if(this.m_hasShadow){
		this.m_cameraShadow = new Engine.OrthographicCamera( -20, 20, 20, -20, 1, 200, "cameraDepth" );
		//this.m_cameraShadow.position = this.m_light.position;
		//this.m_cameraShadow.lookAt(new Engine.Vector3(this.m_light.position.x,0,this.m_light.position.z));

		this.m_cameraShadow.position = new Engine.Vector3(10,40,10);
		this.m_cameraShadow.lookAt(new Engine.Vector3(15,0,15));

		this.m_scene.add(this.m_cameraShadow);
	}

	for( k=0, kl=this.m_meshTiles.length; k<kl;k++){
		this.m_scene.add(this.m_meshTiles[k]);
	}
	for( k=0, kl=this.m_meshElements.length; k<kl;k++){
		this.m_scene.add(this.m_meshElements[k]);
	}

	for(k=0, kl=this.m_subLight.length; k<kl;k++){
		this.m_scene.add(this.m_subLight[k]);
	}

	if(this.m_meshTreasure)
		this.m_scene.add(this.m_meshTreasure);
};


Level.prototype.remove = function(scene) {
	var k=0, kl;
	for(k=0, kl=this.m_meshTiles.length; k<kl;k++){
		this.m_scene.remove(this.m_meshTiles[k]);
	}
	for( k=0, kl=this.m_meshElements.length; k<kl;k++){
		this.m_scene.remove(this.m_meshElements[i]);
	}
	for( k=0, kl=this.m_subLight.length; k<kl;k++){
		this.m_scene.remove(this.m_subLight[k]);
	}
	this.m_scene.remove(this.m_light);
	this.m_scene = null;
};;var startGame = function(dataSkin,dataLevel){

	window.sm = new soundManager();
	var controller, view, level, player, mobsManager, oilGenerator;
	controller = new ControllerManager();
	view = new ViewManager(controller);

	level = new Level(dataSkin.level,dataLevel);
	player = new Player(dataSkin, dataLevel);
	mobsManager = new MobsManager(dataSkin, dataLevel);
	gameManager = new GameManager(dataLevel);
	oilManager = new OilsManager(dataSkin);
	doorManager = new DoorManager(dataLevel);
	controller.setView(view);
	controller.add( level );
	controller.add( player );
	controller.add( mobsManager );
	controller.add( gameManager ); 
	controller.add( oilManager );
	controller.add( doorManager );
	mobsManager.c_setPlayer(player);
	mobsManager.c_setLevel(level);
	doorManager.c_setPlayer(player);
	mobsManager.c_setGameManager(gameManager);
	player.c_setLevel(level);
	gameManager.c_setPlayer( player );
	oilManager.c_setPlayer( player );
	oilManager.c_setLevel(level);
	

	buildInterface(gameManager,dataSkin,dataLevel);

	controller.launch();
};


var buildInterface = function(gameManager,dataSkin,dataLevel){


   		/***************window start****************/

   		var ws = document.getElementById("windowStart");

		/***************window victory****************/

		var wv = document.getElementById("windowVictory");
		wv.children[0].textContent = "Victory";
		var group = wv.children[3];
		group.children[0].textContent = "home";
		wv.style.display = "none";
		Object.observe(gameManager.m_watchedVictory,function(change){
			setTimeout(function(){
				wv.style.display = "block";
			},1000);
		});

		group.children[0].onclick = function(){history.back();}

		/***************window fail****************/
		var wf = document.getElementById("windowFail");
		wf.children[0].textContent = "Fail";
		var group = wf.children[1];
		group.children[0].textContent = "home";
		wf.style.display = "none";
		Object.observe(gameManager.m_watchedLoose,function(change){
			debugger;
			setTimeout(function(){
				wf.style.display = "block";
			},1000);
		});

		window.reloadMap = function(levelId){

	  		var dM = new dataManager();
	        dM.updateCurrentSection('skin0');
	        dM.updateCurrentLevel(levelId);
	        location.reload();
	        /*
	        if(dM.webapp){
	           window.location = window.location.origin+'/ProjectTemplate/game/game.html'; 
	        }else{
	           window.location = '/game';
	        }*/		
		}

		group.children[0].onclick = function(){
			history.back();
		}

};
Mob = function(dataLocal,dataGlobal,material,geometry){

    /******************************************************/
	/**********************MODEL***************************/
	/******************************************************/

	/*****************variable deplacement*****************/
	this.m_position;
	this.m_direction;
	this.m_dirVector;
	this.m_speed;
    this.m_pointTarget;
    this.m_path;
    this.m_goTo;
    this.m_targetReached;
	/*****************variable d'affichage*****************/
	this.m_geometry;
	this.m_material;
	this.m_scene;
	/*****************variable d'etat**********************/
	this.m_currentState;
	this.m_hp;
	this.m_isHurt;
	this.m_follow;
	/*****************variable d'animation*****************/
	this.m_animations;
	/*****************variable timing**********************/
	this.m_interval;
	this.m_counter;
	/*****************variable divers**********************/
	this.m_player;
	this.m_level;
	this.m_pathManager;
	this.m_awakeDistance;
	this.m_attackDistance;
	this.m_errormin;
	this.m_radius;
	this.m_hurtInterval;
	this.m_hurtTimer;

	this.m_scoreValue;

	this.m_hasShadow = true;
	
    /******************************************************/
	this.c_initModel(dataLocal, dataGlobal,material,geometry);

	Mob.count ++;
};

/**********************************************************************************/
/**********************CONTROLLER**************************************************/
/**********************************************************************************/

Mob.count = 0;

Mob.prototype.c_initModel = function(dataLocal,dataGlobal,material,geometry){
	this.m_position = new Engine.Vector3( dataLocal.pos[0],0,dataLocal.pos[1] );
	this.m_direction = dataLocal.rot*Math.PI;
	this.m_goTo = dataLocal.target; //new Engine.Vector3(1,0,15) ;//dataLocal.goTo;
	this.m_speed = dataGlobal.speed;
	this.m_currentState = 0;
	this.m_hp = dataGlobal.hp;
	this.m_animations = dataGlobal.animations;
	this.m_deleted = false;
	this.m_material = material;
	this.m_geometry = geometry;
	this.m_awakeDistance = dataGlobal.awakeRange;
	this.m_errormin = 0.1;
	this.m_pointTarget = new Engine.Vector3();
	this.m_dirVector = new Engine.Vector3();
	this.m_attackDistance = dataGlobal.reach;
	this.m_radius = dataGlobal.size;
	this.m_damage = dataGlobal.damage;
	this.m_gameManager = dataLocal.gm;

	this.m_scoreValue = dataGlobal.value;

	this.m_interval = dataGlobal.reactivity;
	this.m_hurtInterval = 200;
	this.m_counter = 0;
	this.m_follow = false;
	this.m_ctnFinish = 0;
	this.m_ctnBlood = 0;

	this.m_mesh = new Engine.MeshMorph( this.m_geometry, this.m_material, this.m_hasShadow );

	//this.m_helper = new Engine.Mesh( new Engine.CubeGeometry( 0.5, 0.5, 0.5 ), this.m_material );

};



Mob.prototype.c_update = function(t){

	if( this.m_currentState != this.DEAD ){

		var distanceToPlayer = this.m_player.m_position.distanceTo(this.m_position, this.m_player.m_position);

		if(distanceToPlayer<this.m_attackDistance){
			this.c_actionAttack(t);
		}else if(distanceToPlayer<this.m_awakeDistance){
			
			this.c_detectionOfPlayer();

			if(!this.m_follow){
				if(this.m_goTo){
					this.c_actionGoToTarget(t); 
				}else{
					this.c_actionWait();
				}
				
			}else{
				if(!this.m_isHurt ){
					this.c_actionGoToPlayer(t);
				}
			}

		}else{
			if(this.m_goTo){
				this.c_actionGoToTarget(t);
			}else{
				this.c_actionWait();
			}
		}

		if(this.m_player.m_win){

			this.c_dead();
		}
	}else{

		if(this.m_blood.progress>0.95){
			this.m_deleted = true;
		}

		this.m_ctnFinish += t/350;

		this.m_blood.progress = -Math.exp(-this.m_ctnFinish*3)+1;
		//this.m_blood.material.opacity = (1-(this.m_ctnFinish))*2-1;
		//this.m_blood.material.opacity = 1-this.m_ctnFinish//(1-(this.m_ctnFinish))*2-1;
		this.m_blood.material.opacity = Math.cos(this.m_ctnFinish*Math.PI/2)

	}


	if(this.m_counter > this.m_interval){
		this.m_counter = 0;
	}else{
		this.m_counter +=t; 
	}

	this.c_checkDestructionTiles();

	this.c_updateMesh(t);

};



Mob.prototype.c_actionGoToPlayer = function(t){
	this.c_updatePath(t,this.m_player.m_position);
	if(this.m_path&&this.m_path.length)
		this.c_followPath(t);
	this.c_updateDirection(this.m_dirVector.xzToAngle(),t);
	this.m_currentState = this.WALK;
};


Mob.prototype.c_actionAttack = function(t){
	this.m_dirVector.copy(this.m_player.m_position).sub(this.m_position);
	this.c_updateDirection(this.m_dirVector.xzToAngle(),t);
	this.m_player.c_hurt(this.m_damage);
	this.m_currentState = this.SHOOT;
};

Mob.prototype.c_actionGoToTarget = function(t){
	if(this.m_targetReached)return;

	if( this.m_position.distanceTo(this.m_goTo) < this.m_radius) {
		this.m_gameManager.c_MobTakeTarget(this);
		this.m_targetReached = true;
	}

	this.c_updatePath(t,this.m_goTo,1000);
	if(this.m_path&&this.m_path.length)
		this.c_followPath(t);
	this.c_updateDirection(this.m_dirVector.xzToAngle(),t);
	this.m_currentState = this.WALK;
};

Mob.prototype.c_actionWait = function(t){
	this.m_follow = false;
	this.m_currentState = this.WAIT;
};



Mob.prototype.c_updateDirection = function(angle,t){

    angle = Math.to2KPI(angle);

    this.m_direction += Math.subAngle(angle, this.m_direction)*t*0.01;

    this.m_direction = Math.to2KPI(this.m_direction);

};

Mob.prototype.c_detectionOfPlayer = function(){
	if(this.m_counter > this.m_interval && !this.m_follow){
		this.m_dirVector.copy(this.m_player.m_position).sub(this.m_position);
		var e = Math.abs(Math.subAngle(this.m_direction,this.m_dirVector.xzToAngle()));
		if(this.m_pathManager.c_isDirectPath(this.m_position, this.m_player.m_position) && e<Math.PI/2){
			sm.play('assets/sound/monstre0.mp3',1);
			this.m_follow = true;
		}
	}
};




Mob.prototype.c_updatePath = function(t,target,interation){


	if(this.m_counter > this.m_interval){
		this.m_path = this.m_pathManager.findPath(this.m_position, target, interation);
		/*var path = this.m_path
		var m_helper = this.m_helper;
		m_helper.removeAllClones();
		var sizeb = this.m_level.m_blockSize;
		for(var i=0, il= path.length; i<il; i++){
			m_helper.addClone(path[i].x*sizeb,0,path[i].y*sizeb);
		}*/
	}

};

Mob.prototype.c_followPath = function(t){

	var b = this.m_level.m_blockSize;
	var tar = this.m_pointTarget;
	var pos = this.m_position;
	var min = this.m_errormin;
	var dir = this.m_dirVector;
	var a;
	
	if(Math.abs(tar.x-pos.x)<min && Math.abs(tar.z-pos.z)<min ){
		this.m_path.shift();
	}

	if(this.m_path.length){
		tar.x = this.m_path[0].x*b;
		tar.z = this.m_path[0].y*b;	
	}else{
		tar.x = this.m_player.m_position.x*b;
		tar.z = this.m_player.m_position.y*b;		
	}


	dir.set(tar.x,0,tar.z).sub(pos).normalize();

	pos.x += dir.x*this.m_speed;
	pos.z += dir.z*this.m_speed;

};





Mob.prototype.c_dead = function(){
	if(this.m_currentState != this.DEAD){
		this.m_currentState = this.DEAD;
		var self = this;
		this.m_blood.visible = true;
		self.m_mesh.visible = false;
		this.m_blood.position = self.m_position.clone();
		this.m_blood.rotation.y = Math.random()*Math.PI*2;
		this.m_blood.position.y = 1;
		this.m_blood.keyA.index = 0;
		this.m_blood.keyB.index = 1;
		this.m_blood.progress =0;
		this.m_blood.scale.x  = 1;
		this.m_blood.scale.z  = 1;
	}
};



Mob.prototype.c_checkDestructionTiles = function(){
	var p = this.m_position;
	if(this.m_level.c_positionToTile(p.x,p.z).destructor){
		this.m_deleted = true;
	}
};




/**********************************************************************************/
/**********************CONTROLLER GESTION DES ANIMATIONS***************************/
/**********************************************************************************/

Mob.prototype.c_updateMesh = function(t){

	this.m_mesh.position = this.m_position;
	this.m_mesh.rotation.y = -this.m_direction;

	var d = (1-this.m_mesh.scale.x)*0.005;
	this.m_mesh.scale.x += d*t;
	this.m_mesh.scale.z += d*t;	

		
	switch(this.m_currentState){

		case this.WAIT :
				this.m_mesh.setAnimation(this.m_animations.wait,1000,true);
		break;
		case this.WALK :
				this.m_mesh.setAnimation(this.m_animations.walk,500,true);
		break;
		case this.SHOOT :
				this.m_mesh.setAnimation(this.m_animations.shoot,500,true);
		break;
		case this.BEGIN :
				this.m_mesh.setAnimation(this.m_animations.wait,2000,true);
		break;
		case this.DEAD :
				this.m_mesh.setAnimation(this.m_animations.wait,2000,true);
		break;
	}

	this.m_mesh.update(t);
};




Mob.prototype.c_setPlayer = function(player){

	this.m_player = player;

};

Mob.prototype.c_setPathManager = function(pathManager){

	this.m_pathManager = pathManager;

};

Mob.prototype.c_setLevel = function(level){

	this.m_level = level;

	this.m_pathManager.c_setLevel(this.m_level);

	this.m_level.c_addDynamicCollisionBlock(this);

};


Mob.prototype.c_setBlood = function(bloodGeo,bloodMap){
	this.m_blood = new Engine.MeshMorph( bloodGeo,  new Engine.MeshPhongMaterial( { map: bloodMap, transparent : true  } ) );
	this.m_blood.visible = false;
	this.m_blood.rotation.y = Math.random()*Math.PI*2;
	this.m_blood.position.y = 1;
	this.m_blood.keyA.index = 0;
	this.m_blood.keyB.index = 1;

};





/**********************************************************************************/
/**********************CONTROLLER PRIMAIRE*****************************************/
/**********************************************************************************/

Mob.prototype.c_getPosition = function() {
	return this.m_position;
};

Mob.prototype.c_setPosition = function(position) {
	this.m_position = position;
};

Mob.prototype.add = function(scene) {
	scene.add(this.m_mesh);
	scene.add(this.m_blood);
	this.m_scene = scene; 
};

Mob.prototype.remove = function(scene) {

	this.m_level.c_removeDynamicCollisionBlock(this);
	scene.remove(this.m_mesh);
	scene.remove(this.m_blood);
	this.m_scene = null;

	Mob.count -=1;
};

Mob.prototype.WAIT = 1;
Mob.prototype.WALK = 2;
Mob.prototype.SHOOT = 3;
Mob.prototype.DEAD = 9;








;MobsManager = function(dataGlobal, dataLevel){

    this.m_isManager = true;
	this.m_level;
	this.m_material;
	this.m_geometry = [];
	this.m_bloody;
	this.m_player;
	this.m_pathManager;
	this.m_interval;
	this.m_counter;
	this.m_globalCounter;
	this.c_initModel(dataGlobal, dataLevel);
	this.m_limit; 
};

MobsManager.prototype.c_initModel = function(dataGlobal,dataLevel){

	this.m_pathManager = new PathFinding();

	this.m_interval = 200;

	this.m_globalCounter = 0;

	this.m_counter = 0;

	this.m_limit = 200; 

	var dataMobs = dataGlobal.mobs;
	this.m_dataMobs = dataMobs;

	this.m_material = new Engine.MeshPhongMaterial( { map: new Engine.Texture( dataMobs[0].material.colorMap) } );

	this.m_bloody = new Engine.ObjMorphGeometry( "assets/obj/blood/splash.obj" );
	this.m_mapBloody = new Engine.Texture( "assets/textures/bloody.png" );

	for(var l=0,ll=dataMobs.length;l<ll;l++) {
		this.m_geometry.push(new Engine.ObjMorphGeometry( dataMobs[l].geometry )) ;
	}

};



MobsManager.prototype.c_update = function(t){

	var newmob,tile;

	this.m_globalCounter += t;

	if(this.m_counter > this.m_interval){
		this.m_counter = 0;
		this.m_pathManager.c_updateWalkable();
	}else{
		this.m_counter +=t; 
	}

	newmob = this.c_getNearestNewMob(this.m_player.m_n,this.m_player.m_m);

	if(newmob){

		 newmob = new Mob( newmob,this.m_dataMobs[newmob.id],this.m_material,this.m_geometry[newmob.id] );
		 newmob.c_setPlayer(this.m_player);
		 newmob.c_setPathManager(this.m_pathManager);
		 newmob.c_setLevel(this.m_level); 
		 newmob.c_setBlood(this.m_bloody,this.m_mapBloody);
		 return newmob;
	}
};



MobsManager.prototype.c_getMobOfTile = function(tile){
	if(tile){
		return tile.mobs.pop();
	}
};

MobsManager.prototype.c_getNearestNewMob = function(n,m){
	var newmob;
	newmob = this.c_getMobOfTile(this.m_level.c_IndexToTile(n-1,m-1));
	if(newmob) return newmob;
	newmob = this.c_getMobOfTile(this.m_level.c_IndexToTile(n-1,m));
	if(newmob) return newmob;
	newmob = this.c_getMobOfTile(this.m_level.c_IndexToTile(n-1,m+1));
	if(newmob) return newmob;
	newmob = this.c_getMobOfTile(this.m_level.c_IndexToTile(n+1,m-1));
	if(newmob) return newmob;
	newmob = this.c_getMobOfTile(this.m_level.c_IndexToTile(n+1,m));
	if(newmob) return newmob;
	newmob = this.c_getMobOfTile(this.m_level.c_IndexToTile(n+1,m+1));
	if(newmob) return newmob;
	newmob = this.c_getMobOfTile(this.m_level.c_IndexToTile(n,m-1));
	if(newmob) return newmob;
	newmob = this.c_getMobOfTile(this.m_level.c_IndexToTile(n,m+1));
	if(newmob) return newmob;
};


MobsManager.prototype.c_setLevel = function(level){

	this.m_level = level;
	this.m_matrixMap = level.m_matrixMap;

};

MobsManager.prototype.c_setPlayer = function(player){

	this.m_player = player;

};


MobsManager.prototype.c_setGameManager = function(manager){

	this.m_gameManager = manager;

};


;Oil = function(data, material, geometry){

	this.m_id
	this.m_player;
	this.m_scene;
	this.m_mesh;
	this.m_isUsed;
	this.m_hasShadow = true; 

	this.c_initModel(data, material, geometry);
};

Oil.prototype.c_initModel = function(data, material, geometry){
	this.m_id = data.id;
	this.m_position = new Engine.Vector3(data.pos[0],-1,data.pos[1]);
	this.m_mesh = new Engine.Mesh( geometry, material, this.m_hasShadow );
	this.m_mesh.position =  this.m_position;
	this.m_mesh.scale.x = 0;
	this.m_mesh.scale.z = 0;
	this.m_isUsed = false;
}


Oil.prototype.c_update = function(t){


	if(this.m_isUsed){

		this.m_mesh.rotateY(0.002*t);
		var ex = 0-this.m_mesh.scale.x;
		this.m_mesh.scale.x += ex * t * 0.02;
		this.m_mesh.scale.z = this.m_mesh.scale.x;
		if(this.m_mesh.scale.x<0.01){
			this.m_deleted = true;	
		}

	}else if(Math.abs(this.m_position.y)<0.01){
		this.m_position.y = 0;
	    this.m_mesh.scale.x = 1;
	    this.m_mesh.scale.z = 1;
	    this.m_mesh.rotateY(0.001*t);
		var pos = this.m_player.m_position;
		var dx = Math.abs(pos.x-this.m_position.x);
		var dz = Math.abs(pos.z-this.m_position.z);
		if(dx<1&&dz<1){
			this.c_playerUpdate();
		}

	}else{
		var ey = 0-this.m_position.y;
		this.m_position.y += ey * t * 0.005;
		this.m_mesh.scale.x = 1+this.m_position.y;
		this.m_mesh.scale.z = this.m_mesh.scale.x;
		this.m_mesh.rotateY(0.001*( 1-this.m_position.y*10 )*t);
	}

	
}

Oil.prototype.c_playerUpdate = function(){
	this.m_isUsed = true;
	this.m_player.c_takeOil(this.m_id);
};


Oil.prototype.c_setPlayer = function(player){

	this.m_player = player;

};

Oil.prototype.add = function(scene) {
	scene.add(this.m_mesh);
	this.m_scene = scene; 
};

Oil.prototype.remove = function(scene) {
	scene.remove(this.m_mesh);
	this.m_scene = null;
};;OilsManager = function(dataGlobal){

	this.m_isManager = true;
	this.m_level
	this.m_dataOils;
	this.m_dataItem;
	this.m_player;
	this.m_geometry = [];
	this.c_initModel(dataGlobal);
};

OilsManager.prototype.c_initModel = function(dataGlobal){

	this.m_dataOils = dataGlobal.oils;
	
	for (var i=0, il=dataGlobal.oils.length; i < il; i++) {
		this.m_geometry.push( new Engine.ObjGeometry( dataGlobal.oils[i].block ) );
	};

}


OilsManager.prototype.c_update = function(t){

	var oil = this.c_getOilOfTile( this.m_level.c_IndexToTile( this.m_player.m_n, this.m_player.m_m ) );

	if(oil){
		w = new Oil( oil, this.m_player.m_material, this.m_geometry[oil.id] );
		w.c_setPlayer(this.m_player);
		return w;
	}

}

OilsManager.prototype.c_getOilOfTile = function(tile){
	if(tile){
		return tile.oils.pop();
	}
};


OilsManager.prototype.c_setPlayer = function(player){

	this.m_player = player;

};

OilsManager.prototype.c_setLevel = function(level){
	this.m_level = level;
};;
Player = function(dataGlobal,dataLevel){

    /******************************************************/
	/**********************MODEL***************************/
	/******************************************************/

	/*****************variable deplacement*****************/
	this.m_position;
	this.m_lastPosition;
	this.m_direction;
	this.m_moveDirection;
	this.m_speed;
	this.m_n;
	this.m_m;
	/*****************variable d'affichage*****************/
	this.m_meshBody;
	this.m_meshLegs;
	this.m_meshHead;
	this.m_meshLight;
	this.m_material;
	this.m_scene;
	this.m_light;
	this.m_camera;
	this.m_cameraOffset;
	this.m_currentParticleGenerator;
	/*****************variable d'etat**********************/
	this.m_currentState;
	this.m_weapons;
	this.m_currentWeapon;
	this.m_isControlled;
	this.m_hp;
	this.m_hurtDuration;
	this.m_isHurt;
	this.m_lightPower;
	this.m_lightPowerMax;
	this.m_lightIntensity;
	/*****************variable d'animation*****************/
	this.m_animationsBody;
	this.m_animationsLegs;
	this.m_animationsLight;
	this.animationsHead;
	/*****************variable divers**********************/
	this.m_score;
	this.m_ctn0;
	this.m_ctn1;
	this.m_deltaLight;
	this.m_surfaceClick;
	this.m_level;
	this.m_timerHurt;
	this.m_win;
	this.m_hasShadow = true;
    /******************************************************/

	this.c_initModel(dataGlobal,dataLevel);
};

/**********************************************************************************/
/**********************CONTROLLER**************************************************/
/**********************************************************************************/

/**
Pour les variables du model
*/
Player.prototype.c_initModel = function(dataGlobal,dataLevel){

	var dataPlayer = dataGlobal.player;

	var dM = new dataManager();
	var previousLevel = dM.getPreviousLevel();

	var pos = dataLevel.spawnPlayer[Math.round(Math.random()*(dataLevel.spawnPlayer.length-1))];
	this.m_position = new Engine.Vector3(  pos[0],0,pos[1] );

	if(previousLevel){
		var doors = dataLevel.doors;
		for(var k=0,kl=doors.length;k<kl;k++){
			door = doors[k];
			if(door.levelId == previousLevel ){
				pos = this.m_position = new Engine.Vector3(  door.pos[0],0,door.pos[1]+2 );
				break;
			}

		}

	}

	//TODO

	this.m_light = new Engine.PointLight( 0xffffff, 1.0 , 7, [pos[0],3,pos[1]] );
	this.m_lightPower = 1;
	this.m_lightPowerMax = 30;
	this.m_direction = Math.to2KPI(dataPlayer.direction);
	this.m_moveDirection = Math.to2KPI(dataPlayer.direction);
	this.m_speed = dataPlayer.speed;

	this.m_deltaLight = dataPlayer.deltaLight;
	this.m_currentState = this.BEGIN;
	this.m_currentWeapon = 0;
	this.m_weapons = dataGlobal.weapons;
	this.m_isControlled = true;
	this.m_hp = data.hp||100;
	this.m_hurtDuration = dataPlayer.hurtDuration;
	this.m_animationsBody = dataPlayer.animationsBody;
	this.m_animationsLegs = dataPlayer.animationsLegs;
	this.animationsHead = dataPlayer.animationsHead;
	this.m_animationsLight = [{index:1,step:0},{index:0,step:1}];
	this.m_score = 0;
	this.m_ctn0 = 1;
	this.m_ctn1 = 0;
	this.m_deleted = false;
	this.m_lightIntensity = 0;
	this.m_surfaceClick = dataPlayer.surfaceClick;
	this.m_camera = new Engine.PerspectiveCamera( 45, null, 0.1, 100, null, dataPlayer.camera);
	this.m_cameraOffset = dataPlayer.camera;
	this.m_camera.lookAt(new Engine.Vector3(0,0,0));
	this.m_camera.position.x = this.m_position.x + this.m_cameraOffset[0];
	this.m_camera.position.z = this.m_position.z + this.m_cameraOffset[1]; 

	this.m_material = new Engine.MeshPhongMaterial( { 
				map: dataPlayer.material.colorMap?new Engine.Texture( dataPlayer.material.colorMap ):null,
				emissive: dataPlayer.material.emissive,
				specular: dataPlayer.material.specular,
				shininess: dataPlayer.material.shininess,
				lightMap: dataPlayer.material.lightMap?new Engine.Texture( dataPlayer.material.lightMap ):null,
				normalMap: dataPlayer.material.normalMap?new Engine.Texture( dataPlayer.material.normalMap ):null,
				transparent: dataPlayer.material.transparent,
				opacity: dataPlayer.material.opacity||1
			    } );

	this.m_meshBody = new Engine.MeshMorph( new Engine.ObjMorphGeometry( dataPlayer.geometryBody ), this.m_material, this.m_hasShadow );
	this.m_meshLegs = new Engine.MeshMorph( new Engine.ObjMorphGeometry( dataPlayer.geometryLegs ), this.m_material, this.m_hasShadow );
	this.m_meshHead = new Engine.MeshMorph( new Engine.ObjMorphGeometry( dataPlayer.geometryHead ), this.m_material, this.m_hasShadow );


	this.m_meshLight = new Engine.Mesh( new Engine.ObjGeometry( dataPlayer.geometryLight ), this.m_material );
	this.m_meshLight.position = new Engine.Vector3();
	this.m_meshBody.add(this.m_meshLight);


	this.m_script = this.m_scriptBegin();

};


/**
Pour créer et initialiser un générateur de particules
*/
Player.prototype.c_createParticleGenerator = function(data){

			var map = new Engine.Texture( data.bulletMap );
			
			var materialParticle = new Engine.ParticleSystemMaterial({color: 0xffffff, map: map});

			var particlesParams = {
				opacityBegin:1,opacityEnd:1,
				velocityBegin:0.02,velocityEnd:0.02,
				sizeBegin:data.size,sizeEnd:data.size,
				colorBegin:0xffffff,colorEnd:0xffffff,
				angleBegin: 0,angleEnd:0,
				spritSquareVariance:1,
				directionVariance:0,
				numberMax:40,
				frequency:data.frequency,
				duration:400
			};

			var generatorParams = {
				type:"point",
				numberBystep: 1
			};

			return new Engine.ParticlesGenerator( generatorParams,particlesParams,materialParticle/*, this.m_camera*/ );
};


/**
Mise à jour du modele
*/
Player.prototype.c_update = function(t){

	if(this.m_script){
		this.m_script(t);
	}else{ 
		this.c_readEvents(t);
		this.c_checkCollision();		
	}
	this.c_updateMesh(t);
	this.c_updateLight(t);
	this.c_checkSpike();

};



Player.prototype.c_checkSpike = function(){
	var spike;
	var p;
	for (var i=0,il=this.m_level.m_spike.length;i<il;i++) {

		spike = this.m_level.m_spike[i];
		spike.progress = 1;
		spike.keyB = 0;
		for (var k=0,kl=spike.clones.length;k<kl;k++) {
			p = spike.clones[k].elements;
			if( Math.abs(p[12]-this.m_position.x)<1&& Math.abs(p[14]-this.m_position.z)<1) {
				spike.keyB = {index:1,step:1000};
				spike.keyA = {index:1,step:1000};
				this.c_hurt();
			}
		}

	}; 

};


/**
Mise à jour en fonction des events
*/
Player.prototype.c_readEvents = function(t){

	if(this.m_currentState == this.DEAD )return;

	var key = Engine.keys;
	var mouse = Engine.mouse;

	if( key.UP ) {
		if( key.LEFT ) 	   this.c_move(Math.PI*5/4, t);
		else if(key.RIGHT) this.c_move(Math.PI*7/4, t);
		else 			   this.c_move(Math.PI*6/4, t);
	}else if ( key.DOWN ){ 
		if( key.LEFT )     this.c_move(Math.PI*3/4, t);
		else if(key.RIGHT) this.c_move(Math.PI*1/4, t);
		else			   this.c_move(Math.PI/2, t);
		
	} else if ( key.LEFT ) this.c_move(Math.PI, t);		
	 else if ( key.RIGHT ) this.c_move(0, t);
	 else this.c_static();


	if( mouse.downRight && !this.m_isHurt ){
		this.c_shoot(mouse.x,mouse.y);
	}else{
		this.c_straightLook(t);
	}
};

Player.prototype.c_shoot = function(x,y){

	var cam = this.m_scene.camera;
	var positionIn3DSpace = Math.intersectionLinePlane( cam.position, cam.vectorClick(x,y), this.m_surfaceClick );
	this.m_direction = positionIn3DSpace.sub( this.m_position).xzToAngle();

	/*             update state                   */
	if(this.m_currentState == this.WALK || this.m_currentState == this.SHOOTWALK ){
		this.m_currentState = this.SHOOTWALK;
	}else{
		this.m_currentState = this.SHOOT;
	}

};

Player.prototype.c_straightLook = function(t){
	this.m_direction += Math.subAngle(this.m_moveDirection, this.m_direction)*t*0.01;
	this.m_direction = Math.to2KPI(this.m_direction);
};


Player.prototype.c_static = function(){

	this.m_currentState = this.WAIT;	
	this.m_moveDirection = this.m_direction;
};

Player.prototype.c_move = function(angle,t){

	//this.m_moveDirection += Math.subAngle(angle, this.m_moveDirection)*t*0.05;
	//this.m_moveDirection = Math.to2KPI(this.m_moveDirection);
	this.m_moveDirection = Math.to2KPI(angle);

	this.m_position.x += this.m_speed * t * Math.cos(angle);
	this.m_position.z += this.m_speed * t * Math.sin(angle);

	this.m_n = Math.floor(this.m_position.x/this.m_level.m_tileSize);
	this.m_m = Math.floor(this.m_position.z/this.m_level.m_tileSize);

	this.m_camera.position.x = this.m_position.x + this.m_cameraOffset[0];
	this.m_camera.position.z = this.m_position.z + this.m_cameraOffset[1]; 
	//this.m_light.position.x = this.m_position.x+4*Math.cos(this.m_direction);
	//this.m_light.position.z = this.m_position.z+4*Math.sin(this.m_direction);

	this.m_currentState = this.WALK;

	this.m_level.c_updateLight(this.m_position.x,this.m_position.z-3);

};


Player.prototype.c_hurt = function(val){

	if(!this.m_isHurt) {
		this.m_isHurt = true;
		this.m_hp = 0;
		this.c_dead();
	}

};


Player.prototype.c_takeOil = function(id){

	var tab = ['assets/sound/torche_3.mp3','assets/sound/torche.mp3','assets/sound/torche9.mp3'];

	sm.play(tab[Math.floor(Math.random()*2.99)],0);
	this.m_lightPower = 1;
	this.m_lightIntensity = 1;
};

Player.prototype.c_updateLight = function(t){
	this.m_ctn1 +=t;
	this.m_light.distance = 2*(this.m_lightPower/6+Math.pow(this.m_lightPower,0.5)/6)*this.m_lightPowerMax+0.1*Math.cos(this.m_ctn1/50);
	this.m_light.color.r = 1+0.01*Math.cos(this.m_ctn1/45)+this.m_lightIntensity;
	this.m_light.color.g = this.m_light.color.r;
	this.m_light.color.b = this.m_light.color.b;
	console.log(this.m_light.intensity)
	this.m_lightPower -= this.m_deltaLight*t;
	//if(this.m_lightPower < 0.1)this.m_lightPower=0.1;
	if(this.m_lightPower < 0.01 ){
		this.m_lightPower=0.01;
		if(!this.m_flagDark){
			this.m_flagDark = true;
			var that = this;
			this.m_timerDark = setTimeout(function(){
				that.c_hurt();
			},2000);
		}
	}


	this.m_lightIntensity += (0-this.m_lightIntensity)*t*0.02;



	//this.m_lightPower;
	//this.m_lightPowerMax;
};



Player.prototype.c_dead = function(){
	this.m_light.distance = 3;
	this.m_currentState = this.DEAD;
};

Player.prototype.c_killMob = function(score){
	this.m_score += score;
};

Player.prototype.c_getTreasure = function(){
	this.m_hasTreasure = true;
	dM = new dataManager();
    dM.updateHasTreasure(true);
    if(this.m_level.m_meshTreasure)
    this.m_level.m_meshTreasure.visible = false;
}


Player.prototype.c_win = function(){
		this.m_win = true;
		this.m_script = this.m_scriptWin();
}

Player.prototype.c_lose = function(){
	this.m_script = this.m_scriptLose();
}
/**********************************************************************************/
/**********************CONTROLLER GESTION DES ANIMATIONS***************************/
/**********************************************************************************/


Player.prototype.c_updateMesh = function(t){
	this.c_updateMeshBody(t);
	this.c_updateMeshLegs(t);
	this.c_updateMeshHead(t);
	this.c_updateMeshWeapon(t);


	var light = this.m_level.m_light;
	var camShadow = this.m_level.m_cameraShadow;
	light.position.x = this.m_position.x + this.m_cameraOffset[0]+5;
	light.position.z = this.m_position.z + this.m_cameraOffset[1];
	camShadow.position.x = this.m_position.x;
	camShadow.position.z = this.m_position.z;
	this.m_scene._lightsNeedUpdate = true;
};


Player.prototype.c_updateMeshLegs = function(t){
	var pi = Math.PI;
	var e = Math.subAngle(this.m_moveDirection, this.m_direction);
	var em = Math.abs(e);
	var back,straff,left,right;
	var cs = this.m_currentState;

	if( em > pi/2  ) back = true;
	if( em >  pi/4 && em < 3*pi/4 ) straff = true;
	if( e >  0 ) right = true;
	if( e <=  0 ) left = true;

	
	if ( cs == this.WALK || cs == this.SHOOTWALK) {
		var targetDirection;
		if(straff){
			if(left){
				this.m_meshLegs.setAnimation(this.m_animationsLegs.straffLeft,500,true);
				targetDirection = -this.m_moveDirection-pi/2;
			}else{
				this.m_meshLegs.setAnimation(this.m_animationsLegs.straffRight,500,true);
				targetDirection = -this.m_moveDirection+pi/2;
			}
		}else{
			if(back){
				this.m_meshLegs.setAnimation(this.m_animationsLegs.walkBack,500,true);
				targetDirection = -this.m_moveDirection+pi;
			}else{
				this.m_meshLegs.setAnimation(this.m_animationsLegs.walkFront,500,true);
				targetDirection = -this.m_moveDirection;
			}
		}

		/*if(cs != this.SHOOTWALK){
			var eTarget = Math.subAngle(targetDirection, this.m_meshBody.rotation.y);
			this.m_meshBody.rotation.y +=  eTarget*t*0.005;
		}else{
			this.m_meshBody.rotation.y = -this.m_direction;
		}*/

		this.m_meshLegs.rotation.y = -this.m_direction;
	}else{
		if( cs == this.DEAD) 
				this.m_meshLegs.setAnimation(this.m_animationsLegs.lose,1000,false);
		else if( cs == this.VICTORY ){
				this.m_meshLegs.setAnimation(this.m_animationsLegs.win,1000,false);
		}else if(em>0.01){
			this.m_meshLegs.setAnimation(this.m_animationsLegs.straffRotate,500,true);
		}else{
			this.m_meshLegs.setAnimation(this.m_animationsLegs.wait,500,true);
		}
		this.m_meshLegs.rotation.y = -this.m_direction;
	}

	this.m_meshBody.rotation.y = -this.m_direction;

	this.m_meshLegs.position = this.m_position;

	this.m_meshLegs.update(t);
};

Player.prototype.c_updateMeshBody = function(t){

	this.m_meshBody.position = this.m_position;
	//this.m_meshBody.rotation.y = -this.m_direction;
		
	switch(this.m_currentState){

		case this.WAIT :
				console.log()
				this.m_meshBody.setAnimation(this.m_animationsBody.wait,2000,true);
		break;
		case this.WALK :
				this.m_meshBody.setAnimation(this.m_animationsBody.walk,500,true);
		break;
		case this.SHOOT :
			if(this.m_meshBody.keys!=this.m_animationsBody.shoot){
				this.m_meshBody.running = false;
				this.m_meshBody.keys  = this.m_animationsBody.shoot;
				this.m_meshBody.keyA = this.m_animationsBody.shoot[1];
				this.m_meshBody.keyB = this.m_animationsBody.shoot[0];
			}
		break;
		case this.SHOOTWALK :
				this.m_meshBody.setAnimation(this.m_animationsBody.shoot,200,true);	
		break;
		case this.VICTORY :
				this.m_meshBody.setAnimation(this.m_animationsBody.win,1000,false);
		break;
		case this.BEGIN :
				this.m_meshBody.setAnimation(this.m_animationsBody.wait,1000,false);	
		break;
		case this.DEAD :
				this.m_meshBody.setAnimation(this.m_animationsBody.lose,1000,false);	
		break;
		case this.GETWEAPON :
		break; 
	} 

	this.m_meshBody.update(t);
};

Player.prototype.c_updateMeshHead = function(t){
	this.m_meshHead.position.x = this.m_position.x;
	this.m_meshHead.position.z = this.m_position.z;
	this.m_meshHead.rotation.y = -this.m_direction;

	switch(this.m_currentState){

		case this.WAIT :
				this.m_meshHead.setAnimation(this.animationsHead.static,2000,true);
		break;
		case this.WALK :
				this.m_meshHead.setAnimation(this.animationsHead.walk,500,true);
		break;
		case this.SHOOTWALK :
				this.m_meshHead.setAnimation(this.animationsHead.walk,500,true);
		break;
		case this.DEAD :
				this.m_meshHead.setAnimation(this.animationsHead.lose,1000,false);	
		break;
		default :
			this.m_meshHead.setAnimation(this.animationsHead.static,500,true);
		break; 
	} 

	this.m_meshHead.update(t);

};

Player.prototype.c_updateMeshWeapon = function(t){
	
	var m_meshLight =	this.m_meshLight;

	if(this.m_currentState == this.SHOOT || this.m_currentState == this.SHOOTWALK){
		m_meshLight.position.x = 0.8;
		m_meshLight.position.y = 1.3;
		m_meshLight.position.z = -0.2;
		this.m_light.position.x = this.m_position.x+2*Math.cos(this.m_direction);
		this.m_light.position.z = this.m_position.z+2*Math.sin(this.m_direction);
	}else if(this.m_currentState == this.DEAD){
		m_meshLight.position.x = 0.3;
		m_meshLight.position.y = 0.2;
		m_meshLight.position.z = -0.5;
	}else{
		m_meshLight.position.x = 0.3;
		m_meshLight.position.y = 1.0;
		m_meshLight.position.z = -0.5;
		this.m_light.position.x = this.m_position.x+1*Math.cos(this.m_direction);
		this.m_light.position.z = this.m_position.z+1*Math.sin(this.m_direction);
	}

};


Player.prototype.c_setLevel = function(level){

	this.m_level = level;

};



Player.prototype.c_checkCollision = function(){

	if(this.m_level.c_checkCollision(this.m_position,0.2)){
		this.m_position = this.m_lastPosition.clone();
	}else{
		this.m_lastPosition = this.m_position.clone();
	}
};


/**********************************************************************************/
/**********************CONTROLLER SRIPT********************************************/
/**********************************************************************************/

Player.prototype.m_scriptBegin = function(){

	sm.play('assets/sound/torche_3.mp3',0);
	self.m_currentState = self.WAIT;
	self.m_script = null;
};

Player.prototype.m_scriptWin = function(){
	var self = this;
	var dM = new dataManager();
	dM.updateHasTreasure(false);	
	return function(t){
		self.m_currentState = self.VICTORY;
	};
};

Player.prototype.m_scriptLose = function(){
	var self = this;
	var dM = new dataManager();
	dM.updateHasTreasure(false);	
	return function(t){
		self.m_currentState = self.DEAD;
	};
};


/**********************************************************************************/
/**********************CONTROLLER PRIMAIRE*****************************************/
/**********************************************************************************/

Player.prototype.c_getPosition = function() {
	return this.m_position;
};

Player.prototype.c_setPosition = function(position) {
	this.m_position = position;
};

Player.prototype.add = function(scene) {
	scene.add(this.m_meshBody);
	scene.add(this.m_meshLegs); 
	scene.add(this.m_meshHead); 
	scene.add( this.m_camera );
	scene.add(this.m_light);

	this.m_scene = scene; 
};

Player.prototype.remove = function(scene) {
	scene.remove(this.m_meshBody);
	scene.remove(this.m_meshLegs);
	scene.remove(this.m_meshHead);
	scene.remove(this.m_light);
	this.m_scene = null;
};

Player.prototype.WAIT = 1;
Player.prototype.WALK = 2;
Player.prototype.SHOOT = 3;
Player.prototype.SHOOTWALK = 4;
Player.prototype.VICTORY = 7;
Player.prototype.BEGIN = 8;
Player.prototype.DEAD = 9;
Player.prototype.GETWEAPON = 10;
;/************************************************************************/
/******************* SOUND MANAGER **************************************/
/************************************************************************/

function soundManager(){

}


soundManager.prototype = {

    audioPlayer: [],

    play: function (path, layout, loop) {
        if (!this.audioPlayer[layout]) {
            this.audioPlayer[layout] = document.createElement('audio');
            document.body.appendChild(this.audioPlayer[layout]);
            this.audioPlayer[layout].src = path;
            this.audioPlayer[layout].play();
            this.audioPlayer[layout].volume = 0.6;

        } else {
            try {

                this.audioPlayer[layout].currentTime = 0;
                this.audioPlayer[layout].src = path;
                this.audioPlayer[layout].play();
            } catch (e) {
                console.log(e)
            }
        }
    },

    playsrc: function (path, layout) {
        if (!this.audioPlayer[layout]) {
            this.audioPlayer[layout] = document.createElement('audio');
            document.body.appendChild(this.audioPlayer[layout]);
            this.audioPlayer[layout].src = path;
            this.audioPlayer[layout].play();
            this.audioPlayer[layout].volume = 0.6;

        } else {
            this.audioPlayer[layout].src = path;
            this.audioPlayer[layout].play();
        }
    },

    isFinish: function (layout) {
        if (this.audioPlayer[layout])
            return this.audioPlayer[layout].ended;
        else
            return true;
    },

    seek: function (val, layout) {
        this.audioPlayer[layout].currentTime = val;
        this.audioPlayer[layout].play();
    },

    stop: function (layout) {
        this.audioPlayer[layout].stop();
    },

    pause: function (layout) {
        this.audioPlayer[layout].pause();
    },

    resume: function (layout) {
        this.audioPlayer[layout].play();
    },

    setVolume: function (val, layout) {
        this.audioPlayer[layout].volume = val;
    },

    setSrc: function (path, layout) {
        this.audioPlayer[layout].src = path;
        this.audioPlayer[layout].play();
    },

    init: function () {
        var length = this.audioPlayer.length - 1;
        for (var i = length; i > -1; i--)
            delete this.audioPlayer[i];
        this.audioPlayer = [];
    }

};
PathFinding = function(){
	this.m_level;
    this.m_nodes;
    this.m_path;
    this.m_width;
    this.m_height;
    this.m_directPath;
};


PathFinding.prototype.c_setLevel = function(level){

	this.m_level = level;
    this.m_blockSize = level.m_blockSize;

    this.m_N = this.m_level.m_N * this.m_level.m_blockFactor;
    this.m_M = this.m_level.m_M * this.m_level.m_blockFactor;

    this.c_buildNodes();
    
};

PathFinding.prototype.c_init = function(){
    
};

PathFinding.prototype.c_manhattan = function(dx, dy){
     return dx + dy;
};
PathFinding.prototype.c_euclidean = function(dx, dy){
       return Math.sqrt(dx * dx + dy * dy);
};
PathFinding.prototype.c_euclidean = function(dx, dy){
        return Math.max(dx, dy);
};

PathFinding.prototype.c_buildNodes = function(){
        var width = this.m_N,
        height =  this.m_M,
        i = width, j,
        nodes = new Array(width),row;
        while (i--) {
            nodes[i] = new Array(height);
            j = height;
            while (j--) {
                nodes[i][j] = { x:i,y:j};
            }
        }
        this.m_nodes = nodes;  
};

PathFinding.prototype.c_updateWalkable = function(){
        var i = this.m_N; 
        var j;
       
        while (i--) {
            j = this.m_M;
            while (j--) {
                this.m_nodes[i][j].walkable =  !this.m_level.c_getBlockByIndex(i,j);
            }
        }

};

PathFinding.prototype.c_clearNode = function(){
        var node;
        var i = this.m_N; 
        var j = this.m_M;
        while (i--) {
            j = this.m_M;
            while (j--) {
                node = this.m_nodes[i][j];
                node.opened = false;
                node.closed = false;
                node.parent = null;
                node.h = 0;
            }
        }

};

PathFinding.prototype.getNodeAt = function(x,y){
    var n = Math.floor(x/this.m_blockSize);
    var m = Math.floor(y/this.m_blockSize);
    return this.m_nodes[n][m];
};


PathFinding.prototype.getNeighbors = function(node){

        var x = node.x,
        y = node.y,
        neighbors = [],
        nodes = this.m_nodes;


    if (this.isWalkableAt(x, y - 1)) {
        neighbors.push(nodes[x][y - 1]);
    }

    if (this.isWalkableAt(x + 1, y)) {
        neighbors.push(nodes[x + 1][y]);
    }

    if (this.isWalkableAt(x, y + 1)) {
        neighbors.push(nodes[x][y + 1]);
    }

    if (this.isWalkableAt(x - 1, y)) {
        neighbors.push(nodes[x - 1][y]);
    }

    return neighbors;
};


PathFinding.prototype.isWalkableAt = function(x, y) {

    if(this.m_nodes[x] && this.m_nodes[x][y] && (this.m_nodes[x][y].walkable || this.m_nodes[x][y]==this.endNode) ){
    //if(this.m_nodes[x][y].walkable || this.m_nodes[x][y]==this.endNode ){
        return true;
    }else{
        return false;
    }
};


PathFinding.prototype.createPath = function(nodeEnd){

    var parent = nodeEnd.parent;
    var path = [];

    path.push({x:nodeEnd.x,y:nodeEnd.y});

    while(parent){
        path.push({x:parent.x,y:parent.y});
        parent = parent.parent;
    }
    path.reverse();
    path = this.smoothPath(path);
    this.m_path = path;
    return path;
};

PathFinding.prototype.smoothPath = function(path){
    
    var smoothpath = [];
    var currentPoint;
    var nextPoint;
    for(var i=0,il=path.length-1;i<il;i++){
        currentPoint = path[i];
        nextPoint = path[i+1];
        smoothpath[i]={
            x: currentPoint.x+0.5+(nextPoint.x-currentPoint.x)*0.5 ,
            y: currentPoint.y+0.5+(nextPoint.y-currentPoint.y)*0.5
        };
    }
    
    return smoothpath;

};




PathFinding.prototype.c_isDirectPath = function(positionStart, positionEnd){
    var startNode = this.getNodeAt(positionStart.x, positionStart.z);
    var endNode = this.getNodeAt(positionEnd.x, positionEnd.z);

    var x = startNode.x;
    var y = startNode.y;
    var dx = endNode.x - x;
    var dy = endNode.y - y;
    var i = 10;
    while(i--){
        if(!this.isWalkableAt(x+dx,y+dy)){
            return false;
        }
        if(dx!==0){
            dx-=dx/Math.abs(dx);
        }
        if(dy!==0){
            dy-=dy/Math.abs(dy);
        }

        if(dx===0 && dy===0){
            break;
        }
    }

    return true;
};





PathFinding.prototype.findPath = function(positionStart, positionEnd, interation) {

    this.c_clearNode();

    interation = !interation ? 10:interation;
 
    var openList = new Heap(function(nodeA, nodeB) {return nodeA.f - nodeB.f;});

    var startNode = this.getNodeAt(positionStart.x, positionStart.z);
    var endNode = this.getNodeAt(positionEnd.x, positionEnd.z);
    this.endNode = endNode;

    var endX = endNode.x;
    var endY = endNode.y;

    var heuristic = this.c_euclidean;
    var abs = Math.abs, SQRT2 = Math.SQRT2;
    var node, neighbors, neighbor, i, l, x, y, ng;

    // set the `g` and `f` value of the start node to be 0
    startNode.g = 0;
    startNode.f = 0;

    // push the start node into the open list
    openList.push(startNode);
    startNode.opened = true;
    var ctn = 0;
    // while the open list is not empty
    while (!openList.empty() && ctn<interation) {
      
        ctn++;
        // pop the position of node which has the minimum `f` value.
        node = openList.pop();
        node.closed = true;

        // if reached the end position, construct the path and return it
        if (node === endNode) {
            var path = this.createPath(node);
           // this.displayInConsole(startNode,endNode);
            return path;
        }

        // get neigbours of the current node
        neighbors = this.getNeighbors(node);

        var ar = neighbors.length;
        for (i = 0, l = neighbors.length; i < l; ++i) {
            neighbor = neighbors[i];

            if (neighbor.closed && neighbor != endNode) {
                continue;
            }

            x = neighbor.x;
            y = neighbor.y;

            // get the distance between current node and the neighbor
            // and calculate the next g score
            ng = 1;

            // check if the neighbor has not been inspected yet, or
            // can be reached with smaller cost from the current node
            if (!neighbor.opened || ng < neighbor.g) {
                neighbor.g = ng * ar/9; //the trace magic
                neighbor.h = neighbor.h || heuristic(abs(x - endX), abs(y - endY));
                neighbor.f = neighbor.g + neighbor.h;
                neighbor.parent = node;

                if (!neighbor.opened) {
                    //openList.push(neighbor);
                    openList.push(neighbor);
                    neighbor.opened = true;
                } else {
                    // the neighbor can be reached with smaller cost.
                    // Since its f value has been updated, we have to
                    // update its position in the open list

                    //openList.updateItem(neighbor);
                    openList.updateItem(neighbor);
                }
            }
        } // end for each neighbor
    } // end while not open list empty

    // fail to find the path
    //console.log("path fail");
    return [];
};
;// Generated by CoffeeScript 1.8.0
/*jshint -W093 */
/*jshint shadow: true */

(function() {
  var Heap, defaultCmp, floor, heapify, heappop, heappush, heappushpop, heapreplace, insort, min, nlargest, nsmallest, updateItem, _siftdown, _siftup;

  floor = Math.floor, min = Math.min;


  /*
  Default comparison function to be used
   */

  defaultCmp = function(x, y) {
    if (x < y) {
      return -1;
    }
    if (x > y) {
      return 1;
    }
    return 0;
  };


  /*
  Insert item x in list a, and keep it sorted assuming a is sorted.
  
  If x is already in a, insert it to the right of the rightmost x.
  
  Optional args lo (default 0) and hi (default a.length) bound the slice
  of a to be searched.
   */

  insort = function(a, x, lo, hi, cmp) {
    var mid;
    if (lo == null) {
      lo = 0;
    }
    if (cmp == null) {
      cmp = defaultCmp;
    }
    if (lo < 0) {
      throw new Error('lo must be non-negative');
    }
    if (hi == null) {
      hi = a.length;
    }
    while (lo < hi) {
      mid = floor((lo + hi) / 2);
      if (cmp(x, a[mid]) < 0) {
        hi = mid;
      } else {
        lo = mid + 1;
      }
    }
    return ([].splice.apply(a, [lo, lo - lo].concat(x)), x);
  };


  /*
  Push item onto heap, maintaining the heap invariant.
   */

  heappush = function(array, item, cmp) {
    if (cmp == null) {
      cmp = defaultCmp;
    }
    array.push(item);
    return _siftdown(array, 0, array.length - 1, cmp);
  };


  /*
  Pop the smallest item off the heap, maintaining the heap invariant.
   */

  heappop = function(array, cmp) {
    var lastelt, returnitem;
    if (cmp == null) {
      cmp = defaultCmp;
    }
    lastelt = array.pop();
    if (array.length) {
      returnitem = array[0];
      array[0] = lastelt;
      _siftup(array, 0, cmp);
    } else {
      returnitem = lastelt;
    }
    return returnitem;
  };


  /*
  Pop and return the current smallest value, and add the new item.
  
  This is more efficient than heappop() followed by heappush(), and can be
  more appropriate when using a fixed size heap. Note that the value
  returned may be larger than item! That constrains reasonable use of
  this routine unless written as part of a conditional replacement:
      if item > array[0]
        item = heapreplace(array, item)
   */

  heapreplace = function(array, item, cmp) {
    var returnitem;
    if (cmp == null) {
      cmp = defaultCmp;
    }
    returnitem = array[0];
    array[0] = item;
    _siftup(array, 0, cmp);
    return returnitem;
  };


  /*
  Fast version of a heappush followed by a heappop.
   */

  heappushpop = function(array, item, cmp) {
    var _ref;
    if (cmp == null) {
      cmp = defaultCmp;
    }
    if (array.length && cmp(array[0], item) < 0) {
      _ref = [array[0], item], item = _ref[0], array[0] = _ref[1];
      _siftup(array, 0, cmp);
    }
    return item;
  };


  /*
  Transform list into a heap, in-place, in O(array.length) time.
   */

  heapify = function(array, cmp) {
    var i, _i, _j, _len, _ref, _ref1, _results, _results1;
    if (cmp == null) {
      cmp = defaultCmp;
    }
    _ref1 = (function() {
      _results1 = [];
      for (var _j = 0, _ref = floor(array.length / 2); 0 <= _ref ? _j < _ref : _j > _ref; 0 <= _ref ? _j++ : _j--){ _results1.push(_j); }
      return _results1;
    }).apply(this).reverse();
    _results = [];
    for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
      i = _ref1[_i];
      _results.push(_siftup(array, i, cmp));
    }
    return _results;
  };


  /*
  Update the position of the given item in the heap.
  This function should be called every time the item is being modified.
   */

  updateItem = function(array, item, cmp) {
    var pos;
    if (cmp == null) {
      cmp = defaultCmp;
    }
    pos = array.indexOf(item);
    if (pos === -1) {
      return;
    }
    _siftdown(array, 0, pos, cmp);
    return _siftup(array, pos, cmp);
  };


  /*
  Find the n largest elements in a dataset.
   */

  nlargest = function(array, n, cmp) {
    var elem, result, _i, _len, _ref;
    if (cmp == null) {
      cmp = defaultCmp;
    }
    result = array.slice(0, n);
    if (!result.length) {
      return result;
    }
    heapify(result, cmp);
    _ref = array.slice(n);
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      elem = _ref[_i];
      heappushpop(result, elem, cmp);
    }
    return result.sort(cmp).reverse();
  };


  /*
  Find the n smallest elements in a dataset.
   */

  nsmallest = function(array, n, cmp) {
    var elem, i, los, result, _i, _j, _len, _ref, _ref1, _results;
    if (cmp == null) {
      cmp = defaultCmp;
    }
    if (n * 10 <= array.length) {
      result = array.slice(0, n).sort(cmp);
      if (!result.length) {
        return result;
      }
      los = result[result.length - 1];
      _ref = array.slice(n);
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        elem = _ref[_i];
        if (cmp(elem, los) < 0) {
          insort(result, elem, 0, null, cmp);
          result.pop();
          los = result[result.length - 1];
        }
      }
      return result;
    }
    heapify(array, cmp);
    _results = [];
    for (i = _j = 0, _ref1 = min(n, array.length); 0 <= _ref1 ? _j < _ref1 : _j > _ref1; i = 0 <= _ref1 ? ++_j : --_j) {
      _results.push(heappop(array, cmp));
    }
    return _results;
  };

  _siftdown = function(array, startpos, pos, cmp) {
    var newitem, parent, parentpos;
    if (cmp == null) {
      cmp = defaultCmp;
    }
    newitem = array[pos];
    while (pos > startpos) {
      parentpos = (pos - 1) >> 1;
      parent = array[parentpos];
      if (cmp(newitem, parent) < 0) {
        array[pos] = parent;
        pos = parentpos;
        continue;
      }
      break;
    }
    return array[pos] = newitem;
  };

  _siftup = function(array, pos, cmp) {
    var childpos, endpos, newitem, rightpos, startpos;
    if (cmp == null) {
      cmp = defaultCmp;
    }
    endpos = array.length;
    startpos = pos;
    newitem = array[pos];
    childpos = 2 * pos + 1;
    while (childpos < endpos) {
      rightpos = childpos + 1;
      if (rightpos < endpos && (cmp(array[childpos], array[rightpos]) >= 0)) {
        childpos = rightpos;
      }
      array[pos] = array[childpos];
      pos = childpos;
      childpos = 2 * pos + 1;
    }
    array[pos] = newitem;
    return _siftdown(array, startpos, pos, cmp);
  };

  Heap = (function() {
    Heap.push = heappush;

    Heap.pop = heappop;

    Heap.replace = heapreplace;

    Heap.pushpop = heappushpop;

    Heap.heapify = heapify;

    Heap.updateItem = updateItem;

    Heap.nlargest = nlargest;

    Heap.nsmallest = nsmallest;

    function Heap(cmp) {
      this.cmp = cmp != null ? cmp : defaultCmp;
      this.nodes = [];
    }

    Heap.prototype.push = function(x) {
      return heappush(this.nodes, x, this.cmp);
    };

    Heap.prototype.pop = function() {
      return heappop(this.nodes, this.cmp);
    };

    Heap.prototype.peek = function() {
      return this.nodes[0];
    };

    Heap.prototype.contains = function(x) {
      return this.nodes.indexOf(x) !== -1;
    };

    Heap.prototype.replace = function(x) {
      return heapreplace(this.nodes, x, this.cmp);
    };

    Heap.prototype.pushpop = function(x) {
      return heappushpop(this.nodes, x, this.cmp);
    };

    Heap.prototype.heapify = function() {
      return heapify(this.nodes, this.cmp);
    };

    Heap.prototype.updateItem = function(x) {
      return updateItem(this.nodes, x, this.cmp);
    };

    Heap.prototype.clear = function() {
      return this.nodes = [];
    };

    Heap.prototype.empty = function() {
      return this.nodes.length === 0;
    };

    Heap.prototype.size = function() {
      return this.nodes.length;
    };

    Heap.prototype.clone = function() {
      var heap;
      heap = new Heap();
      heap.nodes = this.nodes.slice(0);
      return heap;
    };

    Heap.prototype.toArray = function() {
      return this.nodes.slice(0);
    };

    Heap.prototype.insert = Heap.prototype.push;

    Heap.prototype.top = Heap.prototype.peek;

    Heap.prototype.front = Heap.prototype.peek;

    Heap.prototype.has = Heap.prototype.contains;

    Heap.prototype.copy = Heap.prototype.clone;

    return Heap;

  })();

  if (typeof module !== "undefined" && module !== null ? module.exports : void 0) {
    module.exports = Heap;
  } else {
    window.Heap = Heap;
  }

}).call(this);;



ViewManager = function(controller){

	var res = dM.settingsScreen();

	this.renderer = new Engine.WebGLRenderer( res[0]||1280, res[1]||720 );
	document.body.firstElementChild.appendChild(this.renderer.domElement);
	this.engine = new Engine();
	this.scene = new Engine.Scene();
	var scene = this.scene;
	var renderer = this.renderer;
	var framebufferDepthShadow;
	var framebufferBasic;
	var framebufferLuminance;
	var framebufferGlow;
	var miniMapWidth= gl.viewWidth;
	var miniMapHeight = gl.viewHeight;




	var hasShadow = true;//dM.settingsShadow();
	var hasGlow = dM.settingsGlow();

	if(hasShadow)
		framebufferDepthShadow = new Engine.Framebuffer(256*2,256*2,0xffffff);
	if(hasGlow){
		framebufferBasic = new Engine.Framebuffer( miniMapWidth,miniMapHeight );
		framebufferLuminance = new Engine.Framebuffer( miniMapWidth, miniMapHeight );
		framebufferGlow = new Engine.Framebuffer( miniMapWidth, miniMapHeight );
	}

	this.engine.render = function() {
		if(hasShadow){
			renderer.rendererDepthShadow ( scene, framebufferDepthShadow );
			renderer.renderBasic( scene, null, framebufferDepthShadow );
		}else if(hasShadow,hasGlow){
			renderer.rendererDepthShadow ( scene, framebufferDepthShadow );
			renderer.renderBasic( scene, framebufferBasic, framebufferDepthShadow );
			renderer.renderLuminance(framebufferLuminance,framebufferBasic);
			renderer.renderGlow(framebufferGlow,framebufferLuminance);
			renderer.renderComposer(null,framebufferBasic,framebufferGlow);
		}else{
			renderer.renderBasic( scene );
		}

	};

	this.engine.animate = function(t){
		controller.update(t);
	};

	this.engine.postStart = function(){
		controller.postStart();
	}; 
};


ViewManager.prototype.add = function(element){
	element.add(this.scene);
};

ViewManager.prototype.remove = function(element){
	element.remove(this.scene);
};

ViewManager.prototype.start = function(){
	this.engine.start();
};;
var dataManager = function(){

	this.webapp =  window.location.origin.indexOf('9000')!=-1?false:true;

};

dataManager.prototype.getCurrentLevel = function(){
	return this.getData('l');
};

dataManager.prototype.getCurrentSection = function(){
	return this.getData('s');
};

dataManager.prototype.getCurrentIndexSection = function(){
	return parseInt(this.getData('i'));
};

dataManager.prototype.getProgression = function(){
	return this.getData('p'); 
};

dataManager.prototype.getWorldMap = function(){
	return this.getData('w'); 
};

dataManager.prototype.getHasTreasure = function(){
	return this.getData('t'); 
};

dataManager.prototype.getPreviousLevel = function(){
	return this.getData('previous'); 
};

dataManager.prototype.updateCurrentLevel = function(value){
	this.setData('l',value);
};

dataManager.prototype.updateCurrentSection = function(value){
	this.setData('s',value);
};

dataManager.prototype.updateWorldMap = function(value){
	this.setData('w',value);
};

dataManager.prototype.updateCurrentIndexSection = function(value){
	this.setData('i',value);
};

dataManager.prototype.updateHasTreasure = function(value){
	this.setData('t',value);
};

dataManager.prototype.updatePreviousLevel = function(value){
	this.setData('previous',value);
};




dataManager.prototype.updateProgression = function(data,cb){

	var worldMap = this.getWorldMap();
	var progress = this.getProgression();
	var currentSection = this.getCurrentSection();
	var currentLevel = this.getCurrentLevel();
	var i,il,currentSectionIndex,currentLevelIndex;

	for(i=0,il=worldMap.length;i<il;i++){
		if(worldMap[i].sectionId==currentSection){
			currentSectionIndex=i;
			break;
		}
	}
	var section = worldMap[currentSectionIndex];
	for(i=0,il=section.levels.length;i<il;i++){
		if(section.levels[i].id==currentLevel){
			currentLevelIndex=i;
			break;q
		}
	}

    progress[currentSectionIndex][currentLevelIndex] = data;

   

    	if(currentLevelIndex==progress[currentSectionIndex].length-1){

    		if(currentLevelIndex<section.levels.length-1 ){
    			progress[currentSectionIndex].push(0);
    		}else if(currentSectionIndex==progress.length-1){

    			if(currentSectionIndex<worldMap.length-1 ){
    					progress.push([0]);
    			}	
    		}

    	}

    	console.log(progress);


    this.setData('p',progress);


	if(this.webapp){
		cb();
	}else{
		var request = new XMLHttpRequest();
     	request.open( "POST",'user/update', true );
		request.addEventListener( 
			'load', 
			function ( event ) {
				if(event.target.status == 200){
					event.target.response;
					cb();
				}
			}, 
			true 
		);

		request.send({
			'progress':progress,
			'score':this.getScore()
		});

	}
};

dataManager.prototype.loadUser = function(user){
	this.setData('p',user.progress);
	this.setData('s',0);
	this.setData('l',0);
};

dataManager.prototype.newUser = function(){
	var progress = [[0]];
	this.clearData();
	this.setData('p',progress);//progress
	this.setData('s',0);//currentSection
	this.setData('l',0);//currentLevel
	this.setData('i',0);
	this.setData('t',0);
};

dataManager.prototype.clearData = function(){
	localStorage.clear()
};
dataManager.prototype.getData = function(key){
	return JSON.parse( localStorage.getItem(key) );
};
dataManager.prototype.setData = function(key,value){
	localStorage.setItem(key,JSON.stringify(value))
};

dataManager.prototype.getScore = function(){
	var progress = this.getData('p');
	var stage;
	var score = 0;
	for(var i = 0,il=progress.length;i<il;i++){
		stage = progress[i];
		for(var j = 0,jl=stage.length;j<jl;j++){
			score += stage[j];
		}
	}
	return score;
};

dataManager.prototype.logout = function(cb){

	var request = new XMLHttpRequest();
     	request.open( "GEY",'/user/signout', true );
		request.addEventListener( 
			'load', 
			function ( event ) {
				if(event.target.status == 200){
					cb();
				}
			}, 
			true 
		);

};

dataManager.prototype.settingsShadow = function(value){
	if(value){
		this.setData('shadow',value);
	}else{
		var v = this.getData('shadow'); 
		return v||false;
	}
}

dataManager.prototype.settingsGlow = function(value){
	if(value){
		this.setData('glow',value);
	}else{
		var v = this.getData('glow'); 
		return v||false;
	}
}


dataManager.prototype.settingsScreen = function(value){
	if(value){
		this.setData('screen',value);
	}else{
		var v = this.getData('screen'); 
		v =  v||"1920x1080";
		v = v.split("x");
		return [parseInt(v[0]),parseInt(v[1])]

	}
}

window.dM = new dataManager();

