



ViewManager = function(controller){

	var res = dM.settingsScreen();

	this.renderer = new Engine.WebGLRenderer( res[0]||1280, res[1]||720 );
	document.body.firstElementChild.appendChild(this.renderer.domElement);
	this.engine = new Engine();
	this.scene = new Engine.Scene();
	var scene = this.scene;
	var renderer = this.renderer;
	var framebufferDepthShadow;
	var framebufferBasic;
	var framebufferLuminance;
	var framebufferGlow;
	var miniMapWidth= gl.viewWidth;
	var miniMapHeight = gl.viewHeight;




	var hasShadow = dM.settingsShadow();
	var hasGlow = dM.settingsGlow();

	if(hasShadow)
		framebufferDepthShadow = new Engine.Framebuffer(256*2,256*2,0xffffff);
	if(hasGlow){
		framebufferBasic = new Engine.Framebuffer( miniMapWidth,miniMapHeight );
		framebufferLuminance = new Engine.Framebuffer( miniMapWidth, miniMapHeight );
		framebufferGlow = new Engine.Framebuffer( miniMapWidth, miniMapHeight );
	}

	this.engine.render = function() {
		if(hasShadow){
			renderer.rendererDepthShadow ( scene, framebufferDepthShadow );
			renderer.renderBasic( scene, null, framebufferDepthShadow );
		}else if(hasShadow,hasGlow){
			renderer.rendererDepthShadow ( scene, framebufferDepthShadow );
			renderer.renderBasic( scene, framebufferBasic, framebufferDepthShadow );
			renderer.renderLuminance(framebufferLuminance,framebufferBasic);
			renderer.renderGlow(framebufferGlow,framebufferLuminance);
			renderer.renderComposer(null,framebufferBasic,framebufferGlow);
		}else{
			renderer.renderBasic( scene );
		}

	};

	this.engine.animate = function(t){
		controller.update(t);
	};

	this.engine.postStart = function(){
		controller.postStart();
	}; 
};


ViewManager.prototype.add = function(element){
	element.add(this.scene);
};

ViewManager.prototype.remove = function(element){
	element.remove(this.scene);
};

ViewManager.prototype.start = function(){
	this.engine.start();
};