var app = angular.module('angularHome', ['ngRoute']);
app.config(function ($routeProvider) {
    $routeProvider
      .when('/home', {
        templateUrl: 'js/partials/home.html',
        controller: 'homeCtrl'
      })
      .when('/worldmap', {
        templateUrl: 'js/partials/worldmap.html',
        controller: 'worldmapCtrl'
      })
      .when('/settings', {
        templateUrl: 'js/partials/settings.html',
        controller: 'settingsCtrl'
      })
      .when('/ranking', {
        templateUrl: 'js/partials/ranking.html',
        controller: 'rankingCtrl'
      })
      .otherwise({
        redirectTo: '/home'
      });
  });;app.controller('homeCtrl', function ($scope,$http,$location) {

	$scope.changeView = function(view){
        $location.path(view);
    }

    $scope.logout = function(view){

    	dM.logout(function(data, status) {
         	window.location = 'login';	
        });
    }

    $scope.launch = function(level){
        dM.newUser();
        dM.updateCurrentSection('skin0');
        dM.updateCurrentLevel('level0');
        dM.updateHasTreasure(false);
        dM.updatePreviousLevel(null);
        //if(dM.webapp){
        	debugger;
           window.location = window.location.origin+'/shortlight/game/game.html'; 
       /* }else{
           window.location = '/game';
        }   */
    }

});


app.controller('settingsCtrl', function ($scope,$http,$location) {

	$scope.settings = {
		shadow : ["shadow",false],
		glow : ["glow",false],
		screen : ["screen",["1920x1080","1267x712","960x540"]],
		iscreen : 0
	}



	$scope.backHome = function(){
        debugger;
        dM.settingsShadow($scope.settings.shadow[1]);
        dM.settingsGlow($scope.settings.glow[1]);
        dM.settingsScreen($scope.settings.screen[1][$scope.settings.iscreen]);
		 $location.path("home");
	}

});


app.controller('rankingCtrl', function ($scope,$http,$location) {

	$scope.players = [{login:'alex',score:4500},{login:'mika',score:4000},{login:'victor',score:3500},{login:'justine',score:2000}];

	$scope.backHome = function(){
		 $location.path("home");
	}
});;
var dataManager = function(){

	this.webapp =  window.location.origin.indexOf('9000')!=-1?false:true;

};

dataManager.prototype.getCurrentLevel = function(){
	return this.getData('l');
};

dataManager.prototype.getCurrentSection = function(){
	return this.getData('s');
};

dataManager.prototype.getCurrentIndexSection = function(){
	return parseInt(this.getData('i'));
};

dataManager.prototype.getProgression = function(){
	return this.getData('p'); 
};

dataManager.prototype.getWorldMap = function(){
	return this.getData('w'); 
};

dataManager.prototype.getHasTreasure = function(){
	return this.getData('t'); 
};

dataManager.prototype.getPreviousLevel = function(){
	return this.getData('previous'); 
};

dataManager.prototype.updateCurrentLevel = function(value){
	this.setData('l',value);
};

dataManager.prototype.updateCurrentSection = function(value){
	this.setData('s',value);
};

dataManager.prototype.updateWorldMap = function(value){
	this.setData('w',value);
};

dataManager.prototype.updateCurrentIndexSection = function(value){
	this.setData('i',value);
};

dataManager.prototype.updateHasTreasure = function(value){
	this.setData('t',value);
};

dataManager.prototype.updatePreviousLevel = function(value){
	this.setData('previous',value);
};




dataManager.prototype.updateProgression = function(data,cb){

	var worldMap = this.getWorldMap();
	var progress = this.getProgression();
	var currentSection = this.getCurrentSection();
	var currentLevel = this.getCurrentLevel();
	var i,il,currentSectionIndex,currentLevelIndex;

	for(i=0,il=worldMap.length;i<il;i++){
		if(worldMap[i].sectionId==currentSection){
			currentSectionIndex=i;
			break;
		}
	}
	var section = worldMap[currentSectionIndex];
	for(i=0,il=section.levels.length;i<il;i++){
		if(section.levels[i].id==currentLevel){
			currentLevelIndex=i;
			break;q
		}
	}

    progress[currentSectionIndex][currentLevelIndex] = data;

   

    	if(currentLevelIndex==progress[currentSectionIndex].length-1){

    		if(currentLevelIndex<section.levels.length-1 ){
    			progress[currentSectionIndex].push(0);
    		}else if(currentSectionIndex==progress.length-1){

    			if(currentSectionIndex<worldMap.length-1 ){
    					progress.push([0]);
    			}	
    		}

    	}

    	console.log(progress);


    this.setData('p',progress);


	if(this.webapp){
		cb();
	}else{
		var request = new XMLHttpRequest();
     	request.open( "POST",'user/update', true );
		request.addEventListener( 
			'load', 
			function ( event ) {
				if(event.target.status == 200){
					event.target.response;
					cb();
				}
			}, 
			true 
		);

		request.send({
			'progress':progress,
			'score':this.getScore()
		});

	}
};

dataManager.prototype.loadUser = function(user){
	this.setData('p',user.progress);
	this.setData('s',0);
	this.setData('l',0);
};

dataManager.prototype.newUser = function(){
	var progress = [[0]];
	this.clearData();
	this.setData('p',progress);//progress
	this.setData('s',0);//currentSection
	this.setData('l',0);//currentLevel
	this.setData('i',0);
	this.setData('t',0);
};

dataManager.prototype.clearData = function(){
	localStorage.clear()
};
dataManager.prototype.getData = function(key){
	return JSON.parse( localStorage.getItem(key) );
};
dataManager.prototype.setData = function(key,value){
	localStorage.setItem(key,JSON.stringify(value))
};

dataManager.prototype.getScore = function(){
	var progress = this.getData('p');
	var stage;
	var score = 0;
	for(var i = 0,il=progress.length;i<il;i++){
		stage = progress[i];
		for(var j = 0,jl=stage.length;j<jl;j++){
			score += stage[j];
		}
	}
	return score;
};

dataManager.prototype.logout = function(cb){

	var request = new XMLHttpRequest();
     	request.open( "GEY",'/user/signout', true );
		request.addEventListener( 
			'load', 
			function ( event ) {
				if(event.target.status == 200){
					cb();
				}
			}, 
			true 
		);

};

dataManager.prototype.settingsShadow = function(value){
	if(value){
		this.setData('shadow',value);
	}else{
		var v = this.getData('shadow'); 
		return v||false;
	}
}

dataManager.prototype.settingsGlow = function(value){
	if(value){
		this.setData('glow',value);
	}else{
		var v = this.getData('glow'); 
		return v||false;
	}
}


dataManager.prototype.settingsScreen = function(value){
	if(value){
		this.setData('screen',value);
	}else{
		var v = this.getData('screen'); 
		v =  v||"1920x1080";
		v = v.split("x");
		return [parseInt(v[0]),parseInt(v[1])]

	}
}

window.dM = new dataManager();

