var LocalStrategy   = require('passport-local').Strategy;
var mongoose = require('mongoose');

mongoose.connect('mongodb://localhost/passport');


var User = mongoose.model('User',{
    login: String,
    password: String,
    email: String,
    progress: { type: 'Mixed', default: [] },
    score : Number,
    lastvisit : Date,
    countvisit : Number,
    firstvisit : Date,
});


module.exports = function(passport){

    passport.serializeUser(function(user, done) {
        done(null, user._id);
    });

    passport.deserializeUser(function(id, done) {
        User.findById(id, function(err, user) {
            done(err, user);
        });
    });


    passport.use('login', new LocalStrategy(
        function(username, password, done) {

            User.findOne({ 'login' :  username },
                function(err, user) {
                    if (err){
                        return done(err); 
                    } else if (!user){
                        return done(null, false);                 
                    } else if (password != user.password){
                        return done(null, false);
                    }
                    return done(null, user);
                }
            );

        })
    );

    passport.use('signup', new LocalStrategy(
        {
           passReqToCallback : true     
        },
        function(req, username, password, done) {
            findOrCreateUser = function(){
                User.findOne({ 'login' :  username }, function(err, user) {
                    if (err){
                        return done(err);
                    }
                    if (user) {
                        return done(null, false);
                    } else {
                        console.log("ajout a la DB");
                        var newUser = new User();
                        newUser.login = username;
                        newUser.password = password;
                        newUser.email = req.body.mail;
                        newUser.progress = [[1]];
                        newUser.score = 0;
                        newUser.firstvisit = new Date,
                        newUser.save(function(err) {
                            console.log("ajout termine : "+err);
                            if (err){
                                throw err;  
                            }
                            return done(null, newUser);
                        });
                    }
                });
            };
            process.nextTick(findOrCreateUser);
        })
    );

return User;

}