//TUTO http://mherman.org/blog/2013/11/11/user-authentication-with-passport-dot-js/#.VHEJUfmG_7A
//http://tuts.syrinxoon.net/tuts/authentification-avec-facebook-connect-javascript
//http://fabbook.fr/creer-un-backend-avec-node-js/blogarticle
//http://code.tutsplus.com/tutorials/authenticating-nodejs-applications-with-passport--cms-21619
var express = require('express');
var router = express.Router();




module.exports = function(passport,app,user){

    app.use('/login',express.static('./../login/login.html'));
    app.use('/css/stylelogin.css',express.static( './../login/css/stylelogin.css'));
    app.use('/js/scriptlogin.js',express.static('./../login/js/scriptlogin.js'));
    app.use('/js/bower_components/angular.js',express.static('./../login/js/bower_components/angular.js'));
    app.use('/js/bower_components/hashes.js',express.static('./../login/js/bower_components/hashes.js'));
    app.use('/js/partials',express.static('./../login/js/partials'));

	/* Handle Login POST */
	router.post('/login', passport.authenticate('login'),
        function(req, res) {

            if(req.user){
                console.log(req.user)
                req.session.login = req.user.login;
                req.session.progress = req.user.progress;
                req.session.score = req.user.score;
                req.session.lastvisit = new Date;
                req.session.countvisit = req.user.countvisit = req.user.countvisit++;

                user.findOne({ '_id' :  req.user._id },{lastvisit:1}, function(err, user) {
                    if (user) {
                        user.lastvisit = req.session.lastvisit;
                        req.session.user = user;
                        user.save(function(err) {
                                if (err){
                                    console.log({msg:"lastvisit not updated"});
                                }
                                console.log({msg:"lastvisit updated"});
                        });
                    }
                });

                var json = {
                    success:true,
                    login:req.user.login,
                    score:req.user.score,
                    progress:req.user.progress
                }

                res.json(json);
            }
        },function(){
        console.log("error");
        }
    );

	/* Handle Registration POST */
	router.post('/signup', passport.authenticate('signup', { session: false }),   function(req, res) {
        if(req&&req.user){
            res.json({
                    login: req.user.login,
                    progress:  req.user.progress,
                    score: req.user.score
                });
        }else{
            res.json({success:false});
        }
    });

	/* Handle Logout */
	router.get('/signout', function(req, res) {
		req.logout();
		res.json({success:true});
	});


	router.post('/update', function(req, res) {

            if(req.isAuthenticated()){
            	var user = req.session.use;
                user.progress[req.body.stage][req.body.level] = req.body.score;
                user.score = req.body.score;
                user.lastvisit = new Date;
                user.save(function(err) {
                        if (err){
                            res.json({msg:"progress not saved"});
                        }
                        res.json({msg:"progress saved"});
                });
            }else{
            	res.json({msg:"you must authenticated"});
            }
	});


	router.get('/getData', function(req, res) {
            if(req.isAuthenticated()){
            	res.json({
                    login: req.session.login,
                    progress:  req.session.progress,
                    score: req.session.score
                });
            }else{
            	res.json({msg:"you must authenticated"});
            }
	});

	app.use('/user', router);

}
